:-style_check(-singleton).
grammar_no(1316694702).
:- op(550, xfy, '.').

:- style_check(-singleton).

obldest(neut, neut, neut).

obldest(pyt, pyt, neut).

obldest(pyt, neut, pyt).

obldest(pyt, pyt, pyt).

obldest(pz, pz, pyt).

obldest(pz, pz, neut).

obldest(wz(A, B), wz(A, B), neut).

obldest_iter(A, B, A) :-
	var(B), !.

obldest_iter(neut, neut, neut).

obldest_iter(neut, pyt, pyt).

obldest_iter(pyt, neut, pyt).

obldest_iter(pyt, pyt, pyt).

obldest_iter(wz(A, B), neut, wz(A, B)).

obldest_iter(pz, neut, pz).

obldest_iter(pz, pyt, pz).

obldest_iter(agl, neut, agl).

obldest(A, [A]) :- !.

obldest(C, [A, B|E]) :-
	obldest_iter(A, B, D),
	obldest(C, [D|E]).

tylko_neut_pyt(neut).

tylko_neut_pyt(pyt).

oblzap_iter(bzap, bzap, bzap).

oblzap_iter(bzap, A, B) :-
	nonvar(A),
	member(A, [tk, tyle]),
	A=B, !.

oblzap_iter(A, bzap, B) :-
	nonvar(A),
	member(A, [tk, tyle]),
	A=B, !.

oblzap(A, [A]) :- !.

oblzap(C, [A, B|E]) :-
	oblzap_iter(A, B, D),
	oblzap(C, [D|E]).

oblneg(ani, nie(ani), nie(ani), nie(ani)) :- !.

oblneg(B, A, A, A) :-
	B\=ani.

sprawdz_neg(ani, nie(ani)) :- !.

sprawdz_neg(A, _) :-
	A\=ani.

sprawdz_neg_fzd(ani, []) :- !.

sprawdz_neg_fzd(ani, [nie(ani)|A]) :- !,
	sprawdz_neg_fzd(ani, A).

sprawdz_neg_fzd(A, _) :-
	A\=ani.

oblink(ni, ni, ni) :- !.

oblink(i(A, B), i(A, B), ni) :- !.

oblink(i(A, B), ni, i(A, B)).

oblink_iter(ni, ni, ni) :- !.

oblink_iter(ni, i(A, B), i(A, B)) :- !.

oblink_iter(i(A, B), ni, i(A, B)).

oblink(A, [A]) :- !.

oblink(C, [A, B|E]) :-
	oblink_iter(A, B, D),
	oblink(C, [D|E]).

zgodne_pk(+, 0).

zgodne_pk(-, +).

zgodne_pk(0, 0).

zgodne_pk(0, +).

zgodne_pk(wp, -).

zgodne_pk(wp, 0).

zgodne_pk(+, wb).

zgodne_pk(-, db).

zgodne_pk(+, db).

zgodne_pk(0, db).

sprawdz_pk_iter((A'|'C), (D'|'B), (A'|'B)) :-
	zgodne_pk(C, D).

oblpk(A, [A]) :- !.

oblpk(C, [A, B|E]) :-
	sprawdz_pk_iter(A, B, D),
	oblpk(C, [D|E]).

sprawdz_posiłk(bezpo, A, bezpo) :-
	var(A).

sprawdz_posiłk(bezpo, A, B) :-
	nonvar(A),
	(   A=agl(_)
	->  B=posiłk(A)
	;   B=ost(A)
	).

sprawdz_posiłk(ost(A), B, posiłk(A)) :-
	var(B).

sprawdz_posiłk(posiłk(A), B, posiłk(A)) :-
	var(B).

oblposiłk(bezpo, A, A).

oblposiłk(posiłk(agl(B)), os/A/prze/ozn/3/C, os/A/prze/ozn/B/C).

oblposiłk(posiłk(niech), os/nd/ter/ozn/A/B, os/nd/_/roz/A/B) :-
	member(A, [1, 3]).

oblposiłk(posiłk(niech), os/dk/przy/ozn/A/B, os/nd/_/roz/A/B) :-
	member(A, [1, 3]).

oblposiłk(posiłk(by(C)), A/B/prze/ozn/3/D, A/B/ter/war/C/D) :-
	member(A/C, [os/_, bos/3]).

oblposiłk(posiłk(byłby(B, tak)), os/A/prze/ozn/3/C, os/A/prze/war/B/C).

oblposiłk(posiłk(bedzie(A, B)), os/nd/prze/ozn/3/tak, os/nd/przy/ozn/A/B).

oblposiłk(posiłk(bedzie(A, B)), bok/nd/_/_/_/tak, os/nd/przy/ozn/A/B).

zgodnyznakk(neut, neut).

zgodnyznakk(neut, pyt).

zgodnyznakk(pyt, pyt).

sprawdz_wf(bok, wym(A, B), wym(A, C)) :- !,
	usuń_argument(subj, B, C).

sprawdz_wf(os, A, A) :- !.

sprawdz_wf(bos, A, A).

zroblistę_iter(B, A, [A|B]).

oblwym_iter(wym([A|B], C), A, wym(B, D)) :-
	wyjmijwymaganie2(A, C, D),
	D=[_|_].

najwyżej3(A, _, B) :-
	A<2,
	B is A+1.

conajmniej1(_, _, 1).

dwa_na_listę([A, B|C], [A, B], C).

trzy_na_listę([A, B, C|D], [A, B, C], D).

obl_neg_fwe(psu, A, A, A).

obl_neg_fwe(psw, A, A, A).

obl_neg_fwe(bok, A, tak, A).

obl_neg_fwe(bok, _, nie(A), nie(A)).

sprawdz_fpt_noa((-'|'+)/A/ (+'|'-)/A) :- !.

sprawdz_fpt_noa(B/C/D/A) :-
	oblpk(A, [B, C, D]).

sprawdz_kl_noa(co, A, dop) :-
	równe(A, [mian|bier]), !.

sprawdz_kl_noa(co, A, A) :-
	różne(A, [mian|bier]), !.

sprawdz_kl_noa(B, A, A) :-
	różne(B, co).

sprawdz_kl_nod(A/B) :-
	A\=os,
	B\=kto.

sprawdz_fzd_noz(A/B/C/D, wz(który, A/B), A/B/C/D) :-
	C\=co.

sprawdz_fzd_noz(B/C/A/D, wz(A, B/C), B/C/A/D) :-
	member(A, [kto, co]).

sprawdz_fzd_noz(A/B/C/tk, D, A/B/C/tk) :-
	member(D, [jakby, że, żeby, wz(jaki, _)]).

sprawdz_fzd_noz(A/B/C/tyle, D, A/B/C/tyle) :-
	member(D, [ile, jakby, że, żeby, wz(jaki, _)]).

obldest_fno_iter(A, B, A) :-
	var(B), !.

obldest_fno_iter(neut, neut, neut).

obldest_fno_iter(neut, pyt, pyt).

obldest_fno_iter(pyt, neut, pyt).

obldest_fno_iter(pyt, pyt, pyt).

obldest_fno_iter(wz(A, B), wz(A, B), wz(A, B)).

obldest_fno_iter(pz, pz, pz).

oblparam_fno_koor(A, B/mno/C/egz/_/wym([], [[]]), D/_/E/F/pre, G/_/H/I/pre, J) :-
	member(A, [i, przec, ani, nietylko, tak, zarówno, alei]),
	egzorcyzuj_fno(B, C, [D/E/F, G/H/I|J]).

oblparam_fno_koor(E, A/B/C/D/pre/wym(_, bw), _/_/_/_/pre, A/B/C/D/pre, _) :-
	\+ member(E, [i, przec, ani, nietylko, tak, zarówno, alei]).

oblparam_fno_koor(_, A/B/C/D/post/wym(_, bw), A/B/C/D/post, _/_/_/_/pre, _).

egzorcyzuj_fno(r(_, nmo(_)), 3, []) :- !.

egzorcyzuj_fno(E, H, [D/G/A|B]) :-
	member(A, [rzecz, os, uzg, egz]),
	egzorcyzuj_fno(C, F, B),
	egzorcyzuj_rodz(C, D, E),
	egzorcyzuj_os(F, G, H).

egzorcyzuj_os(A, _, A) :-
	var(A), !.

egzorcyzuj_os(_, A, A) :-
	var(A), !.

egzorcyzuj_os(A, B, A) :-
	A<B, !.

egzorcyzuj_os(B, A, A) :-
	B>=A.

egzorcyzuj_rodz(r(mn(m(zy)), mo), _, r(mn(m(zy)), mo)) :- !.

egzorcyzuj_rodz(_, r(mn(m(zy)), mo), r(mn(m(zy)), mo)) :- !.

egzorcyzuj_rodz(_, _, r(_, nmo(_))).

same_cyfry(A) :-
	atom_codes(A, B),
	\+ (   member(C, B),
	   \+ (   C>=48,
	      C=<57
	      )
	   ).

wypowiedzenie(_, _, _) :-
	fail.

zdanie(E, A, G, H, I, J, K, L, M, N, B, O, D, na) :-
	goal(znakkonca(C, po), A, F, P),
	zgodnyznakk(B, C),
	oblpk(_, [ (+'|'wp), D, (+'|'+)]),
	register(wypowiedzenie, E, F, w, [G/zdanie(H, I, J, K, L, M, N, B, O, D, na), A, P/znakkonca(C, po)], Q),
	wypowiedzenie(E, F, Q).

zdanie(S, B, U, I, J, K, L, M, N, O, A, Q, F, po) :-
	tylko_neut_pyt(A),
	goal(przec(G, po), B, C, V),
	goal(spójnik(rc, X, ni, na), C, D, W),
	goal(zdanie(Z, A1, B1, C1, D1, E1, F1, E, ni, H, po), D, T, Y),
	obldest(P, [A, E]),
	oblpk(R, [F, G, H]),
	register(zdanie(I, J, K, L, M, N, O, P, Q, R, H1), S, T, r1, [U/zdanie(I, J, K, L, M, N, O, A, Q, F, po), B, V/przec(G, po), C, W/spójnik(rc, X, ni, na), D, Y/zdanie(Z, A1, B1, C1, D1, E1, F1, E, ni, H, po)], G1),
	zdanie(S, T, G1, I, J, K, L, M, N, O, P, Q, R, H1).

zdanie(P, A, R, F, G, H, I, J, K, L, neut, N, D, po) :-
	goal(przec(T, na), A, B, S),
	goal(zdanie(V, W, X, Y, Z, A1, B1, C, i(r, C1), E, po), B, Q, U),
	obldest(M, [neut, C]),
	oblpk(O, [D, (+'|'wp), E]),
	register(zdanie(F, G, H, I, J, K, L, M, N, O, E1), P, Q, r2, [R/zdanie(F, G, H, I, J, K, L, neut, N, D, po), A, S/przec(T, na), B, U/zdanie(V, W, X, Y, Z, A1, B1, C, i(r, C1), E, po)], D1),
	zdanie(P, Q, D1, F, G, H, I, J, K, L, M, N, O, E1).

zdanie(M1, B, O1, C1, D1, E1, F1, G1, H1, I1, A, K1, Z, po) :-
	tylko_neut_pyt(A),
	sequence_of(P1, [C, P/spójnik(szk, D, ni, na), O, Y/zdanie(Q, R, S, T, U, V, W, X, ni, F, po)], B, C, [[spójnik(sz, D, ni, po), zdanie(H, I, J, K, L, M, N, G, ni, E, po), przec(_, po)]^[trzy_na_listę, A1, [ (0 '|' 0), E, (+'|'wp)], [ (0 '|' 0), F]]^[obldest_iter, A, G, B1]^[H]^[I]^[J]^[K]^[L]^[M]^[N]^[conajmniej1, 0, _, 1]]),
	goal(spójnik(szk, D, ni, na), C, O, P),
	różne(D, [przec, czy]),
	goal(zdanie(Q, R, S, T, U, V, W, X, ni, F, po), O, N1, Y),
	oblpk(L1, [Z|A1]),
	obldest_iter(B1, X, J1),
	register(zdanie(C1, D1, E1, F1, G1, H1, I1, J1, K1, L1, R1), M1, N1, s2, [O1/zdanie(C1, D1, E1, F1, G1, H1, I1, A, K1, Z, po)|P1], Q1),
	zdanie(M1, N1, Q1, C1, D1, E1, F1, G1, H1, I1, J1, K1, L1, R1).

zdanie(N1, B, P1, D1, E1, F1, G1, H1, I1, J1, A, L1, A1, po) :-
	tylko_neut_pyt(A),
	sequence_of(Q1, [C, P/spójnik(szk, N, ni, na), O, Z/zdanie(R, S, T, U, V, W, X, Y, ni, E, po)], B, C, [[spójnik(sz, przec, ni, po), zdanie(G, H, I, J, K, L, M, F, ni, D, po)]^[dwa_na_listę, B1, [ (+'|'wp), D], [Q, E]]^[obldest_iter, A, F, C1]^[G]^[H]^[I]^[J]^[K]^[L]^[M]]),
	goal(spójnik(szk, N, ni, na), C, O, P),
	N\=czy,
	(   N=przec
	->  Q= (+'|'wp)
	;   Q= (db'|'0)
	),
	goal(zdanie(R, S, T, U, V, W, X, Y, ni, E, po), O, O1, Z),
	oblpk(M1, [A1|B1]),
	obldest_iter(C1, Y, K1),
	register(zdanie(D1, E1, F1, G1, H1, I1, J1, K1, L1, M1, S1), N1, O1, s3, [P1/zdanie(D1, E1, F1, G1, H1, I1, J1, A, L1, A1, po)|Q1], R1),
	zdanie(N1, O1, R1, D1, E1, F1, G1, H1, I1, J1, K1, L1, M1, S1).

zdanie(S, B, U, I, J, K, L, M, N, O, A, Q, F, po) :-
	tylko_neut_pyt(A),
	goal(przec(G, po), B, C, V),
	goal(spójnik(pc, X, ni, na), C, D, W),
	goal(zdanie(Z, A1, B1, C1, D1, E1, F1, E, ni, H, po), D, T, Y),
	obldest(P, [A, E]),
	oblpk(R, [F, G, H]),
	register(zdanie(I, J, K, L, M, N, O, P, Q, R, H1), S, T, p1, [U/zdanie(I, J, K, L, M, N, O, A, Q, F, po), B, V/przec(G, po), C, W/spójnik(pc, X, ni, na), D, Y/zdanie(Z, A1, B1, C1, D1, E1, F1, E, ni, H, po)], G1),
	zdanie(S, T, G1, I, J, K, L, M, N, O, P, Q, R, H1).

zdanie(P, A, R, F, G, H, I, J, K, L, neut, N, D, na) :-
	goal(przec(T, po), A, B, S),
	goal(zdanie(V, W, X, Y, Z, A1, B1, C, i(p, C1), E, po), B, Q, U),
	obldest(M, [neut, C]),
	oblpk(O, [D, (+'|'wp), E]),
	register(zdanie(F, G, H, I, J, K, L, M, N, O, E1), P, Q, p4, [R/zdanie(F, G, H, I, J, K, L, neut, N, D, na), A, S/przec(T, po), B, U/zdanie(V, W, X, Y, Z, A1, B1, C, i(p, C1), E, po)], D1),
	zdanie(P, Q, D1, F, G, H, I, J, K, L, M, N, O, E1).

zdanie(K, A, M, N, E, F, G, O, P, H, C, I, D, na) :-
	optional(Q, [], A, L, przec(B, po), {}, {B= (+'|'-)}),
	równe(C, [wz(_, _), pz]),
	oblpk(J, [ (-'|'+), D, B]),
	register(fzd(C, nk, E, F, G, H, I, J, S), K, L, zd2, [M/zdanie(N, E, F, G, O, P, H, C, I, D, na)|Q], R),
	fzd(K, L, R, C, nk, E, F, G, H, I, J, S).

pauza(W, A, Y, po) :-
	optional(Z, [B, N/zdanie(D, E, F, G, H, I, J, K, L, M, na)|O], A, B, cudz(o, po), {C=t}, {C=f}),
	goal(zdanie(D, E, F, G, H, I, J, K, L, M, na), B, P, N),
	optional(O, [Q, T/znakkonca(S, po)|U], P, Q, cudz(z, po), {C=t, R=t}, {R=f}),
	goal(znakkonca(S, po), Q, V, T),
	optional(U, [], V, X, cudz(z, po), {C=t, R=f}, { (C=f;R=t)}),
	zgodnyznakk(K, S),
	oblpk(_, [ (+'|'wp), M, (+'|'+)]),
	register(wypowiedzenie, W, X, w2, [Y/pauza(po)|Z], A1),
	wypowiedzenie(W, X, A1).

pauza(A1, A, C1, po) :-
	optional(D1, [B, G/spójnik(D, E, ni, na), F, R/zdanie(H, I, J, K, L, M, N, O, P, Q, po)|S], A, B, cudz(o, po), {C=t}, {C=f}),
	goal(spójnik(D, E, ni, na), B, F, G),
	member(D/E, [szk/i, szk/albo, szk/bądź, szk/lub, szk/ani, rc/natomiast, rc/alei, rc/a, po/żeby, po/że, po/zanim, po/ponieważ, po/podczas, po/jeśli, po/gdyby, po/gdy, po/dopóki, po/choćby, po/chociaż, po/aż1, pc/więc, pc/bo]),
	goal(zdanie(H, I, J, K, L, M, N, O, P, Q, po), F, T, R),
	optional(S, [U, X/znakkonca(W, po)|Y], T, U, cudz(z, po), {C=t, V=t}, {V=f}),
	goal(znakkonca(W, po), U, Z, X),
	optional(Y, [], Z, B1, cudz(z, po), {C=t, V=f}, { (C=f;V=t)}),
	zgodnyznakk(O, W),
	oblpk(_, [ (+'|'wp), Q, (+'|'+)]),
	register(wypowiedzenie, A1, B1, w6, [C1/pauza(po)|D1], E1),
	wypowiedzenie(A1, B1, E1).

cudz(K, A, M, o, po) :-
	goal(zdanie(O, P, Q, R, S, T, U, I, V, J, na), A, B, N),
	optional(W, [C, F/znakkonca(E, po)|G], B, C, cudz(z, po), {D=t}, {D=f}),
	goal(znakkonca(E, po), C, H, F),
	optional(G, [], H, L, cudz(z, po), {D=f}, {D=t}),
	zgodnyznakk(I, E),
	oblpk(_, [ (+'|'wp), J, (+'|'+)]),
	register(wypowiedzenie, K, L, w3, [M/cudz(o, po), A, N/zdanie(O, P, Q, R, S, T, U, I, V, J, na)|W], X),
	wypowiedzenie(K, L, X).

nawias(L, A, N, o, D, po) :-
	goal(zdanie(P, Q, R, S, T, U, V, J, W, K, na), A, B, O),
	optional(X, [C, G/znakkonca(F, po)|H], B, C, nawias(z, D, po), {E=t}, {E=f}),
	goal(znakkonca(F, po), C, I, G),
	optional(H, [], I, M, nawias(z, D, po), {E=f}, {E=t}),
	zgodnyznakk(J, F),
	oblpk(_, [ (+'|'wp), K, (+'|'+)]),
	register(wypowiedzenie, L, M, w4, [N/nawias(o, D, po), A, O/zdanie(P, Q, R, S, T, U, V, J, W, K, na)|X], Y),
	wypowiedzenie(L, M, Y).

spójnik(H, C, J, A, B, ni, na) :-
	member(A/B, [szk/i, szk/albo, szk/bądź, szk/lub, szk/ani, rc/natomiast, rc/alei, rc/a, rc/czyli, po/żeby, po/że, po/zanim, po/ponieważ, po/podczas, po/jeśli, po/gdyby, po/gdy, po/dopóki, po/choćby, po/chociaż, po/aż1, pc/więc, pc/bo]),
	goal(zdanie(L, M, N, O, P, Q, R, E, S, G, po), C, D, K),
	goal(znakkonca(F, po), D, I, T),
	zgodnyznakk(E, F),
	oblpk(_, [ (+'|'wp), G, (+'|'+)]),
	register(wypowiedzenie, H, I, w5, [J/spójnik(A, B, ni, na), C, K/zdanie(L, M, N, O, P, Q, R, E, S, G, po), D, T/znakkonca(F, po)], U),
	wypowiedzenie(H, I, U).

spójnik(U, A, W, rl, D, S, na) :-
	goal(zdanie(K, L, M, N, O, P, Q, B, ni, H, po), A, C, X),
	tylko_neut_pyt(B),
	goal(przec(I, po), C, E, Y),
	goal(spójnik(rp, D, ni, po), E, F, Z),
	goal(zdanie(B1, C1, D1, E1, F1, G1, H1, G, ni, J, po), F, V, A1),
	obldest(R, [B, G]),
	oblpk(T, [H, I, J]),
	register(zdanie(K, L, M, N, O, P, Q, R, S, T, J1), U, V, r3, [W/spójnik(rl, D, S, na), A, X/zdanie(K, L, M, N, O, P, Q, B, ni, H, po), C, Y/przec(I, po), E, Z/spójnik(rp, D, ni, po), F, A1/zdanie(B1, C1, D1, E1, F1, G1, H1, G, ni, J, po)], I1),
	zdanie(U, V, I1, K, L, M, N, O, P, Q, R, S, T, J1).

spójnik(R1, B, T1, sz, A, ni, na) :-
	\+ member(A, [przec, lub]),
	goal(zdanie(H1, I1, J1, K1, L1, M1, N1, C, P1, E1, po), B, D, U1),
	tylko_neut_pyt(C),
	sequence_of(V1, [E, S/przec(H, po), R, U/spójnik(szk, A, ni, po), T, D1/zdanie(V, W, X, Y, Z, A1, B1, C1, ni, I, po)], D, E, [[przec(F, po), spójnik(sz, A, ni, po), zdanie(K, L, M, N, O, P, Q, J, ni, G, po)]^[trzy_na_listę, F1, [F, (0 '|' 0), G], [H, (0 '|' 0), I]]^[obldest_iter, C, J, G1]^[K]^[L]^[M]^[N]^[O]^[P]^[Q]]),
	goal(przec(H, po), E, R, S),
	goal(spójnik(szk, A, ni, po), R, T, U),
	A\=czy,
	goal(zdanie(V, W, X, Y, Z, A1, B1, C1, ni, I, po), T, S1, D1),
	oblpk(Q1, [ (0 '|' 0), E1|F1]),
	obldest_iter(G1, C1, O1),
	register(zdanie(H1, I1, J1, K1, L1, M1, N1, O1, P1, Q1, X1), R1, S1, s1, [T1/spójnik(sz, A, ni, na), B, U1/zdanie(H1, I1, J1, K1, L1, M1, N1, C, P1, E1, po)|V1], W1),
	zdanie(R1, S1, W1, H1, I1, J1, K1, L1, M1, N1, O1, P1, Q1, X1).

spójnik(P, A, R, pl, C, ni, na) :-
	goal(zdanie(G, H, I, J, K, L, M, B, ni, E, po), A, D, S),
	tylko_neut_pyt(B),
	goal(fzd(C, nk, U, V, W, X, N, F, po), D, Q, T),
	oblpk(O, [ (0 '|' 0), E, F]),
	register(zdanie(G, H, I, J, K, L, M, B, N, O, Z), P, Q, p3, [R/spójnik(pl, C, ni, na), A, S/zdanie(G, H, I, J, K, L, M, B, ni, E, po), D, T/fzd(C, nk, U, V, W, X, N, F, po)], Y),
	zdanie(P, Q, Y, G, H, I, J, K, L, M, B, N, O, Z).

spójnik(G1, A, I1, rl, D, E1, na) :-
	goal(fno(F, N/O, P, wym([], K1), Q, G, R, H, B, ni, K, po), A, C, J1),
	tylko_neut_pyt(B),
	goal(przec(L, po), C, E, L1),
	goal(spójnik(rp, D, ni, po), E, I, M1),
	goal(fno(F, S/T, U, wym([], O1), V, G, W, H, J, ni, M, po), I, H1, N1),
	obldest_fno_iter(B, J, D1),
	oblpk(F1, [K, L, M]),
	oblparam_fno_koor(D, X/Y/Z/B1/C1/A1, N/O/P/Q/R, S/T/U/V/W, []),
	register(fno(F, X/Y, Z, A1, B1, G, C1, H, D1, E1, F1, Q1), G1, H1, nor2, [I1/spójnik(rl, D, E1, na), A, J1/fno(F, N/O, P, wym([], K1), Q, G, R, H, B, ni, K, po), C, L1/przec(L, po), E, M1/spójnik(rp, D, ni, po), I, N1/fno(F, S/T, U, wym([], O1), V, G, W, H, J, ni, M, po)], P1),
	fno(G1, H1, P1, F, X/Y, Z, A1, B1, G, C1, H, D1, E1, F1, Q1).

spójnik(W1, B, Y1, sz, A, ni, na) :-
	\+ member(A, [przec, lub]),
	goal(fno(D, H1/I1, J1, wym([], A2), K1, E, L1, F, C, U1, E1, po), B, G, Z1),
	tylko_neut_pyt(C),
	sequence_of(B2, [H, T/przec(K, po), S, V/spójnik(szk, A, ni, na), U, D1/fno(D, W/X, Y, wym([], Z), A1, E, B1, F, C1, ni, L, po)], G, H, [[przec(I, po), spójnik(sz, A, ni, na), fno(D, N/Q, O, wym([], R), P, E, pre, F, M, ni, J, po)]^[trzy_na_listę, F1, [I, (0 '|' 0), J], [K, (0 '|' 0), L]]^[obldest_fno_iter, C, M, G1]^[zroblistę_iter, [], N/O/P, M1]^[Q]^[R]]),
	goal(przec(K, po), H, S, T),
	goal(spójnik(szk, A, ni, na), S, U, V),
	sprawdz_neg(A, F),
	goal(fno(D, W/X, Y, wym([], Z), A1, E, B1, F, C1, ni, L, po), U, X1, D1),
	oblpk(V1, [E1|F1]),
	obldest_fno_iter(G1, C1, T1),
	oblparam_fno_koor(A, N1/O1/P1/R1/S1/Q1, H1/I1/J1/K1/L1, W/X/Y/A1/B1, M1),
	register(fno(D, N1/O1, P1, Q1, R1, E, S1, F, T1, U1, V1, D2), W1, X1, nos1, [Y1/spójnik(sz, A, ni, na), B, Z1/fno(D, H1/I1, J1, wym([], A2), K1, E, L1, F, C, U1, E1, po)|B2], C2),
	fno(W1, X1, C2, D, N1/O1, P1, Q1, R1, E, S1, F, T1, U1, V1, D2).

spójnik(L, A, N, po, D, J, na) :-
	goal(zdanie(P, F, G, H, Q, R, I, neut, ni, E, po), A, B, O),
	optional(S, [], B, M, przec(C, po), {}, {C= (+'|'-)}),
	member(D, [aż, chociaż, czy, dopóki, gdy, jak, jeśli, podczas, ponieważ, zanim, że]),
	oblpk(K, [ (-'|'+), E, C]),
	register(fzd(D, nk, F, G, H, I, J, K, U), L, M, zds1o, [N/spójnik(po, D, J, na), A, O/zdanie(P, F, G, H, Q, R, I, neut, ni, E, po)|S], T),
	fzd(L, M, T, D, nk, F, G, H, I, J, K, U).

spójnik(N, A, P, po, F, L, na) :-
	goal(zdanie(R, H, I, J, S, B, K, C, ni, G, po), A, D, Q),
	member(B/C, [3/neut, _/agl]),
	optional(T, [], D, O, przec(E, po), {}, {E= (+'|'-)}),
	member(F, [choćby, gdyby, jakby, jakoby, żeby]),
	oblpk(M, [ (-'|'+), G, E]),
	register(fzd(F, nk, H, I, J, K, L, M, V), N, O, zds2o, [P/spójnik(po, F, L, na), A, Q/zdanie(R, H, I, J, S, B, K, C, ni, G, po)|T], U),
	fzd(N, O, U, F, nk, H, I, J, K, L, M, V).

spójnik(O, B, Q, rl, E, A, na) :-
	goal(fzd(C, G, J, K, L, M, A, S, po), B, D, R),
	C\=wz(_, _),
	goal(przec(U, po), D, F, T),
	goal(spójnik(rp, E, ni, po), F, H, V),
	goal(fzd(C, G, X, Y, Z, A1, ni, I, po), H, P, W),
	oblpk(N, [_, (+'|'wp), I]),
	register(fzd(C, G, J, K, L, M, A, N, C1), O, P, zdr2, [Q/spójnik(rl, E, A, na), B, R/fzd(C, G, J, K, L, M, A, S, po), D, T/przec(U, po), F, V/spójnik(rp, E, ni, po), H, W/fzd(C, G, X, Y, Z, A1, ni, I, po)], B1),
	fzd(O, P, B1, C, G, J, K, L, M, A, N, C1).

spójnik(G1, B, I1, sz, A, ni, po) :-
	\+ member(A, [przec, lub]),
	goal(fzd(C, D, B1, C1, D1, K, E1, Z, po), B, E, J1),
	C\=wz(_, _),
	sequence_of(K1, [F, Q/przec(I, po), P, S/spójnik(szk, A, ni, na), R, Y/fzd(C, D, V, W, X, T, ni, J, po)], E, F, [[przec(G, po), spójnik(sz, A, ni, po), fzd(C, D, M, N, O, L, ni, H, po)]^[trzy_na_listę, A1, [G, (0 '|' wp), H], [I, (0 '|' wp), J]]^[zroblistę_iter, [K], L, U]^[M]^[N]^[O]]),
	goal(przec(I, po), F, P, Q),
	goal(spójnik(szk, A, ni, na), P, R, S),
	sprawdz_neg_fzd(A, [T|U]),
	goal(fzd(C, D, V, W, X, T, ni, J, po), R, H1, Y),
	oblpk(F1, [ (0 '|' wp), Z|A1]),
	register(fzd(C, D, B1, C1, D1, K, E1, F1, M1), G1, H1, zdsz1, [I1/spójnik(sz, A, ni, po), B, J1/fzd(C, D, B1, C1, D1, K, E1, Z, po)|K1], L1),
	fzd(G1, H1, L1, C, D, B1, C1, D1, K, E1, F1, M1).

spójnik(F, A, H, B, C, ni, na) :-
	goal(spójnik(i(D, E), J, ni, po), A, G, I),
	register(spójnik(B, C, i(D, E), L), F, G, si, [H/spójnik(B, C, ni, na), A, I/spójnik(i(D, E), J, ni, po)], K),
	spójnik(F, G, K, B, C, i(D, E), L).

ff(W, C, Y, A, D, E, S, F, G, B, H, N, O, P, na) :-
	sprawdz_wf(A, B, I),
	sequence_of(Z, [], C, X, [fw(J, D, E, F, G, post, H, K, L, M, po)^[oblwym_iter, I, J, Q], fl(D, E, F, G, H, K, L, M, po)^[najwyżej3, 0, _, _]]^[obldest_iter, N, K, T]^[oblink_iter, O, L, U]^[sprawdz_pk_iter, P, M, V]),
	Q=wym([], R),
	resztawym(R),
	register(zdanie(A, D, E, S, F, G, H, T, U, V, B1), W, X, ze1, [Y/ff(A, D, E, S, F, G, B, H, N, O, P, na)|Z], A1),
	zdanie(W, X, A1, A, D, E, S, F, G, H, T, U, V, B1).

fw(Z1, B, B2, H, D, E, A, F, pre, G, M, N, O, po) :-
	sequence_of(C2, [C, A1/ff(Q, R, S, T, A, U, V, W, X, Y, Z, na)|I1], B, C, [fw(I, D, E, A, F, pre, G, J, K, L, po)^[zroblistę_iter, [H], I, G1], fl(D, E, A, F, G, J, K, L, po)^[najwyżej3, 0, _, P1], posiłk(P, A, J, K, L, po)]^[obldest_iter, M, J, D1]^[oblink_iter, N, K, E1]^[sprawdz_pk_iter, O, L, F1]^[sprawdz_posiłk, bezpo, P, B1]),
	goal(ff(Q, R, S, T, A, U, V, W, X, Y, Z, na), C, J1, A1),
	oblposiłk(B1, Q/R/S/T/U/W, C1/D/E/V1/F/G),
	sprawdz_wf(C1, V, H1),
	obldest_iter(D1, X, Q1),
	oblink_iter(E1, Y, R1),
	sprawdz_pk_iter(F1, Z, S1),
	wyjmijl(G1, H1, K1),
	sequence_of(I1, [], J1, A2, [fw(L1, D, E, A, F, post, G, M1, N1, O1, po)^[oblwym_iter, K1, L1, T1], fl(D, E, A, F, G, M1, N1, O1, po)^[najwyżej3, P1, _, _]]^[obldest_iter, Q1, M1, W1]^[oblink_iter, R1, N1, X1]^[sprawdz_pk_iter, S1, O1, Y1]),
	T1=wym([], U1),
	resztawym(U1),
	register(zdanie(C1, D, E, V1, A, F, G, W1, X1, Y1, E2), Z1, A2, ze2, [B2/fw(H, D, E, A, F, pre, G, M, N, O, po)|C2], D2),
	zdanie(Z1, A2, D2, C1, D, E, V1, A, F, G, W1, X1, Y1, E2).

fw(N1, E, P1, H, A, B, C, D, pre, G, L, L1, M, po) :-
	sequence_of(Q1, [F, T/fwe(N, A, B, O, C, D, P, Q, R, ni, S, na)|Y], E, F, [fw(I, A, B, C, D, pre, G, J, ni, K, po)^[zroblistę_iter, [H], I, W], fl(A, B, C, D, G, J, ni, K, po)^[najwyżej3, 0, _, E1]]^[obldest_iter, L, J, U]^[sprawdz_pk_iter, M, K, V]),
	goal(fwe(N, A, B, O, C, D, P, Q, R, ni, S, na), F, Z, T),
	member(N, [bok, psu, psw]),
	wykluczpodmiot(P, X),
	obldest_iter(U, R, F1),
	sprawdz_pk_iter(V, S, G1),
	wyjmijl(W, X, A1),
	sequence_of(Y, [], Z, O1, [fw(B1, A, B, C, D, post, G, C1, ni, D1, po)^[oblwym_iter, A1, B1, H1], fl(A, B, C, D, G, C1, ni, D1, po)^[najwyżej3, E1, _, _]]^[obldest_iter, F1, C1, K1]^[sprawdz_pk_iter, G1, D1, M1]),
	H1=wym([], I1),
	resztawym(I1),
	obl_neg_fwe(N, J1, Q, G),
	register(fwe(N, A, B, O, C, D, wym(S1, []), J1, K1, L1, M1, T1), N1, O1, wew2, [P1/fw(H, A, B, C, D, pre, G, L, L1, M, po)|Q1], R1),
	fwe(N1, O1, R1, N, A, B, O, C, D, wym(S1, []), J1, K1, L1, M1, T1).

fw(W2, B, Y2, W, Z2, A3, B3, C3, pre, A, Y, Z, A1, po) :-
	sequence_of(D3, [C, J1/fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na)|Q1], B, C, [[optional(przec(D, po), {}, {D= (-'|'+)}), fpt(K1, E/F, I, wym([], K), J, L, A, M, N, H, po), optional(przec(G, po), {}, {G= (+'|'-)})]^[sprawdz_fpt_noa, D/H/G/O]^[I]^[J]^[K], fpm(P, Q, R, L, A, M, N, O, po)^[P]^[Q]^[R], fno(dop, S, 3, wym([], T), V, L, pre, A, M, N, O, po)^[S]^[T]^[sprawdz_kl_nod, U/V], fw(X, _, _, _, _, post, A, M, ni, O, po)^[zroblistę_iter, [W], X, P1], modpart(fno, A, M, ni, O, po)]^[oblzap_iter, bzap, L, L1]^[obldest_iter, Y, M, M1]^[oblink_iter, Z, N, N1]^[sprawdz_pk_iter, A1, O, O1]),
	goal(fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na), C, R1, J1),
	D1=wym(_, [_|_]),
	sprawdz_kl_noa(U, B1, K1),
	oblzap_iter(L1, E1, M2),
	obldest_iter(M1, G1, O2),
	oblink_iter(N1, H1, P2),
	sprawdz_pk_iter(O1, I1, Q2),
	wyjmijl(P1, D1, K2),
	sequence_of(Q1, [], R1, X2, [[optional(przec(S1, po), {}, {S1= (-'|'+)}), fpt(K1, E/F, V1, wym([], X1), W1, Y1, A, Z1, A2, U1, po), optional(przec(T1, po), {}, {T1= (+'|'-)})]^[sprawdz_fpt_noa, S1/U1/T1/B2]^[V1]^[W1]^[X1], fpm(C2, D2, E2, Y1, A, Z1, A2, B2, po)^[C2]^[D2]^[E2], fno(dop, F2, 3, wym([], G2), H2, Y1, pre, A, Z1, A2, B2, po)^[F2]^[G2]^[sprawdz_kl_nod, U/H2], fzd(I2, nk, _, _, _, J2, ni, B2, po)^[sprawdz_fzd_noz, E/F/U/N2, I2, _]^[J2], fw(L2, _, _, _, _, post, A, Z1, ni, B2, po)^[oblwym_iter, K2, L2, R2], modpart(fno, A, Z1, ni, B2, po)]^[oblzap_iter, M2, Y1, N2]^[obldest_iter, O2, Z1, T2]^[oblink_iter, P2, A2, U2]^[sprawdz_pk_iter, Q2, B2, V2]),
	R2=wym([], S2),
	resztawym(S2),
	register(fno(B1, E/F, C1, wym(F3, bw), U, N2, F1, A, T2, U2, V2, G3), W2, X2, now2, [Y2/fw(W, Z2, A3, B3, C3, pre, A, Y, Z, A1, po)|D3], E3),
	fno(W2, X2, E3, B1, E/F, C1, wym(F3, bw), U, N2, F1, A, T2, U2, V2, G3).

fw(G2, A, I2, M, J2, K2, L2, M2, post, tak, S, T, U, po) :-
	sequence_of(N2, [B, C1/fpt(P, Q, V, W, X, Y, O, Z, A1, B1, na)|I1], A, B, [fps(C, D, E, F, G, H, po)^[C]^[D]^[E], fpm(I, J, K, R, L, F, G, H, po)^[I]^[J]^[K]^[L], fw(N, _, _, _, _, post, tak, F, G, H, po)^[zroblistę_iter, [M], N, H1], modpart(fpt, O, F, G, H, po), modjaki(P, Q, R, F, G, H, po)]^[oblzap_iter, _, R, D1]^[obldest_iter, S, F, E1]^[oblink_iter, T, G, F1]^[sprawdz_pk_iter, U, H, G1]),
	goal(fpt(P, Q, V, W, X, Y, O, Z, A1, B1, na), B, J1, C1),
	W=wym(_, [_|_]),
	oblzap_iter(D1, Y, X1),
	obldest_iter(E1, Z, Y1),
	oblink_iter(F1, A1, Z1),
	sprawdz_pk_iter(G1, B1, A2),
	wyjmijl(H1, W, U1),
	sequence_of(I1, [], J1, H2, [fps(K1, L1, M1, N1, O1, P1, po)^[K1]^[L1]^[M1], fpm(Q1, R1, S1, W1, T1, N1, O1, P1, po)^[Q1]^[R1]^[S1]^[T1], fw(V1, _, _, _, _, post, tak, N1, O1, P1, po)^[oblwym_iter, U1, V1, B2], modpart(fpt, O, N1, O1, P1, po), modjaki(P, Q, W1, N1, O1, P1, po)]^[oblzap_iter, X1, W1, C2]^[obldest_iter, Y1, N1, D2]^[oblink_iter, Z1, O1, E2]^[sprawdz_pk_iter, A2, P1, F2]),
	sprawdz_reszte(B2),
	register(fpt(P, Q, V, wym(P2, bw), X, C2, O, D2, E2, F2, Q2), G2, H2, ptw2, [I2/fw(M, J2, K2, L2, M2, post, tak, S, T, U, po)|N2], O2),
	fpt(G2, H2, O2, P, Q, V, wym(P2, bw), X, C2, O, D2, E2, F2, Q2).

fl(Y1, B, A2, D, E, A, F, G, L, M, N, po) :-
	sequence_of(B2, [C, Z/ff(P, Q, R, S, A, T, U, V, W, X, Y, na)|H1], B, C, [fw(H, D, E, A, F, pre, G, I, J, K, po)^[zroblistę_iter, [], H, F1], fl(D, E, A, F, G, I, J, K, po)^[najwyżej3, 0, _, O1], posiłk(O, A, I, J, K, po)]^[obldest_iter, L, I, C1]^[oblink_iter, M, J, D1]^[sprawdz_pk_iter, N, K, E1]^[sprawdz_posiłk, bezpo, O, A1]),
	goal(ff(P, Q, R, S, A, T, U, V, W, X, Y, na), C, I1, Z),
	oblposiłk(A1, P/Q/R/S/T/V, B1/D/E/U1/F/G),
	sprawdz_wf(B1, U, G1),
	obldest_iter(C1, W, P1),
	oblink_iter(D1, X, Q1),
	sprawdz_pk_iter(E1, Y, R1),
	wyjmijl(F1, G1, J1),
	sequence_of(H1, [], I1, Z1, [fw(K1, D, E, A, F, post, G, L1, M1, N1, po)^[oblwym_iter, J1, K1, S1], fl(D, E, A, F, G, L1, M1, N1, po)^[najwyżej3, O1, _, _]]^[obldest_iter, P1, L1, V1]^[oblink_iter, Q1, M1, W1]^[sprawdz_pk_iter, R1, N1, X1]),
	S1=wym([], T1),
	resztawym(T1),
	register(zdanie(B1, D, E, U1, A, F, G, V1, W1, X1, D2), Y1, Z1, ze3, [A2/fl(D, E, A, F, G, L, M, N, po)|B2], C2),
	zdanie(Y1, Z1, C2, B1, D, E, U1, A, F, G, V1, W1, X1, D2).

fl(M1, E, O1, A, B, C, D, G, K, K1, L, po) :-
	sequence_of(P1, [F, S/fwe(M, A, B, N, C, D, O, P, Q, ni, R, na)|X], E, F, [fw(H, A, B, C, D, pre, G, I, ni, J, po)^[zroblistę_iter, [], H, V], fl(A, B, C, D, G, I, ni, J, po)^[najwyżej3, 0, _, D1]]^[obldest_iter, K, I, T]^[sprawdz_pk_iter, L, J, U]),
	goal(fwe(M, A, B, N, C, D, O, P, Q, ni, R, na), F, Y, S),
	member(M, [bok, psu, psw]),
	wykluczpodmiot(O, W),
	obldest_iter(T, Q, E1),
	sprawdz_pk_iter(U, R, F1),
	wyjmijl(V, W, Z),
	sequence_of(X, [], Y, N1, [fw(A1, A, B, C, D, post, G, B1, ni, C1, po)^[oblwym_iter, Z, A1, G1], fl(A, B, C, D, G, B1, ni, C1, po)^[najwyżej3, D1, _, _]]^[obldest_iter, E1, B1, J1]^[sprawdz_pk_iter, F1, C1, L1]),
	G1=wym([], H1),
	resztawym(H1),
	obl_neg_fwe(M, I1, P, G),
	register(fwe(M, A, B, N, C, D, wym(R1, []), I1, J1, K1, L1, S1), M1, N1, wew3, [O1/fl(A, B, C, D, G, K, K1, L, po)|P1], Q1),
	fwe(M1, N1, Q1, M, A, B, N, C, D, wym(R1, []), I1, J1, K1, L1, S1).

posiłk(Z1, C, B2, A, B, M, N, O, po) :-
	sprawdz_posiłk(bezpo, A, P),
	sequence_of(C2, [D, A1/ff(Q, R, S, T, B, U, V, W, X, Y, Z, na)|I1], C, D, [fw(E, F, G, B, H, pre, I, J, K, L, po)^[zroblistę_iter, [], E, G1], fl(F, G, B, H, I, J, K, L, po)^[najwyżej3, 0, _, P1]]^[obldest_iter, M, J, D1]^[oblink_iter, N, K, E1]^[sprawdz_pk_iter, O, L, F1]^[sprawdz_posiłk, P, _, B1]),
	goal(ff(Q, R, S, T, B, U, V, W, X, Y, Z, na), D, J1, A1),
	oblposiłk(B1, Q/R/S/T/U/W, C1/F/G/V1/H/I),
	sprawdz_wf(C1, V, H1),
	obldest_iter(D1, X, Q1),
	oblink_iter(E1, Y, R1),
	sprawdz_pk_iter(F1, Z, S1),
	wyjmijl(G1, H1, K1),
	sequence_of(I1, [], J1, A2, [fw(L1, F, G, B, H, post, I, M1, N1, O1, po)^[oblwym_iter, K1, L1, T1], fl(F, G, B, H, I, M1, N1, O1, po)^[najwyżej3, P1, _, _]]^[obldest_iter, Q1, M1, W1]^[oblink_iter, R1, N1, X1]^[sprawdz_pk_iter, S1, O1, Y1]),
	T1=wym([], U1),
	resztawym(U1),
	register(zdanie(C1, F, G, V1, B, H, I, W1, X1, Y1, E2), Z1, A2, ze4, [B2/posiłk(A, B, M, N, O, po)|C2], D2),
	zdanie(Z1, A2, D2, C1, F, G, V1, B, H, I, W1, X1, Y1, E2).

fzd(R, A, T, B, nk, U, V, W, X, P, F, po) :-
	goal(przec(G, po), A, C, Y),
	goal(spójnik(pp, B, ni, na), C, D, Z),
	goal(zdanie(I, J, K, L, M, N, O, E, ni, H, po), D, S, A1),
	tylko_neut_pyt(E),
	oblpk(Q, [F, G, H]),
	register(zdanie(I, J, K, L, M, N, O, E, P, Q, C1), R, S, p2, [T/fzd(B, nk, U, V, W, X, P, F, po), A, Y/przec(G, po), C, Z/spójnik(pp, B, ni, na), D, A1/zdanie(I, J, K, L, M, N, O, E, ni, H, po)], B1),
	zdanie(R, S, B1, I, J, K, L, M, N, O, E, P, Q, C1).

fzd(D, E, F, A, nk, G, H, I, J, B, C, na) :-
	member(A, [aż, czy, jak, jakby, jakoby, mie1, mie2, mie3, pz, że, żeby]),
	register(fw(sentp(A), L, M, N, O, P, Q, neut, B, C, R), D, E, wyz1, [F/fzd(A, nk, G, H, I, J, B, C, na)], K),
	fw(D, E, K, sentp(A), L, M, N, O, P, Q, neut, B, C, R).

fzd(E, F, G, A, B, H, I, J, K, C, D, na) :-
	member(A, [aż, czy, jak, jakby, jakoby, mie1, mie2, mie3, pz, że, żeby]),
	\+ member(B, [bier, nk, _/_]),
	register(fw(sentp(B, A), M, N, O, P, Q, R, neut, C, D, S), E, F, wyz2, [G/fzd(A, B, H, I, J, K, C, D, na)], L),
	fw(E, F, L, sentp(B, A), M, N, O, P, Q, R, neut, C, D, S).

fzd(D, E, F, A, dop, G, H, I, J, B, C, na) :-
	member(A, [aż, czy, jak, jakby, jakoby, mie1, mie2, mie3, pz, że, żeby]),
	register(fw(sentp(bier, A), L, M, N, O, P, nie(Q), neut, B, C, R), D, E, wyz3, [F/fzd(A, dop, G, H, I, J, B, C, na)], K),
	fw(D, E, K, sentp(bier, A), L, M, N, O, P, nie(Q), neut, B, C, R).

fzd(D, E, F, A, bier, G, H, I, J, B, C, na) :-
	member(A, [aż, czy, jak, jakby, jakoby, mie1, mie2, mie3, pz, że, żeby]),
	register(fw(sentp(bier, A), L, M, N, O, P, tak, neut, B, C, Q), D, E, wyz4, [F/fzd(A, bier, G, H, I, J, B, C, na)], K),
	fw(D, E, K, sentp(bier, A), L, M, N, O, P, tak, neut, B, C, Q).

fzd(F, G, H, A, B/C, I, J, K, L, D, E, na) :-
	member(A, [aż, czy, jak, jakby, jakoby, mie1, mie2, mie3, pz, że, żeby]),
	register(fw(sentp(B, C, A), N, O, P, Q, R, S, neut, D, E, T), F, G, wyz5, [H/fzd(A, B/C, I, J, K, L, D, E, na)], M),
	fw(F, G, M, sentp(B, C, A), N, O, P, Q, R, S, neut, D, E, T).

fzd(C, D, E, dopóki, nk, F, G, H, I, A, B, na) :-
	register(fl(nd, K, L, M, tak, neut, A, B, N), C, D, luz1, [E/fzd(dopóki, nk, F, G, H, I, A, B, na)], J),
	fl(C, D, J, nd, K, L, M, tak, neut, A, B, N).

fzd(C, D, E, dopóki, nk, F, G, H, I, A, B, na) :-
	register(fl(K, L, M, N, nie(nie), neut, A, B, O), C, D, luz2, [E/fzd(dopóki, nk, F, G, H, I, A, B, na)], J),
	fl(C, D, J, K, L, M, N, nie(nie), neut, A, B, O).

fzd(D, E, F, A, nk, G, H, I, J, B, C, na) :-
	member(A, [choćby, gdyby]),
	register(fl(L, M, N, O, P, neut, B, C, Q), D, E, luz3, [F/fzd(A, nk, G, H, I, J, B, C, na)], K),
	fl(D, E, K, L, M, N, O, P, neut, B, C, Q).

fzd(E, F, G, B, nk, H, I, A, J, C, D, na) :-
	nonvar(A),
	member(B, [aż2, gdy, zanim, bo, co, chociaż, czy, jak, jakby, jeśli, podczas, ponieważ]),
	register(fl(L, M, N, O, P, neut, C, D, Q), E, F, luz9, [G/fzd(B, nk, H, I, A, J, C, D, na)], K),
	fl(E, F, K, L, M, N, O, P, neut, C, D, Q).

fzd(D, E, F, A, nk, G, H, I, J, B, C, na) :-
	member(A, [żeby]),
	register(fl(L, M, N, O, P, neut, B, C, Q), D, E, luz10, [F/fzd(A, nk, G, H, I, J, B, C, na)], K),
	fl(D, E, K, L, M, N, O, P, neut, B, C, Q).

fzd(C, D, E, wz(F, przys), nk, G, H, I, J, A, B, na) :-
	register(fl(L, M, N, O, P, neut, A, B, Q), C, D, luz11, [E/fzd(wz(F, przys), nk, G, H, I, J, A, B, na)], K),
	fl(C, D, K, L, M, N, O, P, neut, A, B, Q).

fzd(N, A, P, C, D, H, I, J, K, L, F, po) :-
	goal(przec(R, po), A, B, Q),
	goal(spójnik(rc, T, ni, na), B, E, S),
	goal(fzd(C, D, V, W, X, Y, ni, G, po), E, O, U),
	oblpk(M, [F, (+'|'wp), G]),
	register(fzd(C, D, H, I, J, K, L, M, A1), N, O, zdr1, [P/fzd(C, D, H, I, J, K, L, F, po), A, Q/przec(R, po), B, S/spójnik(rc, T, ni, na), E, U/fzd(C, D, V, W, X, Y, ni, G, po)], Z),
	fzd(N, O, Z, C, D, H, I, J, K, L, M, A1).

fzd(D1, C, F1, A, B, Y, Z, A1, H, B1, X, po) :-
	sequence_of(G1, [D, N/spójnik(szk, E, ni, na), M, T/fzd(A, B, Q, R, S, O, ni, G, po)], C, D, [[spójnik(sz, E, ni, po), fzd(A, B, J, K, L, I, ni, F, po), przec(_, po)]^[trzy_na_listę, U, [ (+'|'wp), F, (+'|'0)], [ (0 '|' wp), G]]^[zroblistę_iter, [H], I, P]^[J]^[K]^[L]^[conajmniej1, 0, _, 1]]),
	goal(spójnik(szk, E, ni, na), D, M, N),
	E\=przec,
	sprawdz_neg_fzd(E, [O|P]),
	goal(fzd(A, B, Q, R, S, O, ni, G, po), M, E1, T),
	(   B=nk
	->  V=U
	;   U=[ (+'|'wp)|W],
	    V=[ (wb'|'wp)|W]
	),
	oblpk(C1, [X|V]),
	register(fzd(A, B, Y, Z, A1, H, B1, C1, I1), D1, E1, zdsz2, [F1/fzd(A, B, Y, Z, A1, H, B1, X, po)|G1], H1),
	fzd(D1, E1, H1, A, B, Y, Z, A1, H, B1, C1, I1).

fzd(C1, D, E1, C, A, X, Y, Z, H, A1, V, po) :-
	(   A=nk
	->  B= +
	;   B=wb
	),
	sequence_of(F1, [E, O/spójnik(szk, M, ni, na), N, U/fzd(C, A, R, S, T, P, ni, G, po)], D, E, [[spójnik(sz, przec, ni, po), fzd(C, A, J, K, L, I, ni, F, po)]^[dwa_na_listę, W, [ (+'|'wp), F], [ (B'|'wp), G]]^[zroblistę_iter, [H], I, Q]^[J]^[K]^[L]]),
	goal(spójnik(szk, M, ni, na), E, N, O),
	sprawdz_neg_fzd(M, [P|Q]),
	goal(fzd(C, A, R, S, T, P, ni, G, po), N, D1, U),
	oblpk(B1, [V|W]),
	register(fzd(C, A, X, Y, Z, H, A1, B1, H1), C1, D1, zdsz3, [E1/fzd(C, A, X, Y, Z, H, A1, V, po)|F1], G1),
	fzd(C1, D1, G1, C, A, X, Y, Z, H, A1, B1, H1).

fwe(L, M, N, A, B, C, D, E, F, G, H, I, J, K, na) :-
	równe(A, [os, bos, bok]),
	register(ff(A, B, C, D, E, F, G, H, I, J, K, P), L, M, fi1, [N/fwe(A, B, C, D, E, F, G, H, I, J, K, na)], O),
	ff(L, M, O, A, B, C, D, E, F, G, H, I, J, K, P).

fwe(I, J, K, bok, C, D, L, M, N, wym([], A), B, F, G, H, na) :-
	(   A=[]
	*-> E=B
	;   true
	),
	register(fw(infp(C), P, D, Q, R, S, E, F, G, H, T), I, J, wy1, [K/fwe(bok, C, D, L, M, N, wym([], A), B, F, G, H, na)], O),
	fw(I, J, O, infp(C), P, D, Q, R, S, E, F, G, H, T).

fwe(G, A, I, psw, J, E, K, L, M, wym([], N), O, neut, F, B, na) :-
	optional(P, [], A, H, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	register(fl(R, E, S, T, U, neut, F, D, V), G, H, luw1o, [I/fwe(psw, J, E, K, L, M, wym([], N), O, neut, F, B, na)|P], Q),
	fl(G, H, Q, R, E, S, T, U, neut, F, D, V).

fwe(F, A, H, psu, I, prze, J, K, L, wym([], M), N, neut, E, B, na) :-
	optional(O, [], A, G, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	register(fl(Q, R, S, T, U, neut, E, D, V), F, G, luw2o, [H/fwe(psu, I, prze, J, K, L, wym([], M), N, neut, E, B, na)|O], P),
	fl(F, G, P, Q, R, S, T, U, neut, E, D, V).

fwe(G, A, I, psu, J, E, K, L, M, wym([], N), O, neut, F, B, na) :-
	optional(P, [], A, H, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	E\=prze,
	register(fl(R, przy, S, T, U, neut, F, D, V), G, H, luw3o, [I/fwe(psu, J, E, K, L, M, wym([], N), O, neut, F, B, na)|P], Q),
	fl(G, H, Q, R, przy, S, T, U, neut, F, D, V).

fwe(W, C, Y, A, D, E, R, F, G, B, Q, M, U, N, na) :-
	member(A, [bok, psu, psw]),
	wykluczpodmiot(B, H),
	sequence_of(Z, [], C, X, [fw(I, D, E, F, G, post, J, K, ni, L, po)^[oblwym_iter, H, I, O], fl(D, E, F, G, J, K, ni, L, po)^[najwyżej3, 0, _, _]]^[obldest_iter, M, K, T]^[sprawdz_pk_iter, N, L, V]^[conajmniej1, 0, _, 1]),
	O=wym([], P),
	resztawym(P),
	obl_neg_fwe(A, S, Q, J),
	register(fwe(A, D, E, R, F, G, wym(B1, []), S, T, U, V, C1), W, X, wew1, [Y/fwe(A, D, E, R, F, G, B, Q, M, U, N, na)|Z], A1),
	fwe(W, X, A1, A, D, E, R, F, G, wym(B1, []), S, T, U, V, C1).

fpm(G, H, I, A, B, J, K, C, D, E, F, na) :-
	register(fw(prepnp(A, B), M, N, O, P, Q, C, D, E, F, R), G, H, wy2, [I/fpm(A, B, J, K, C, D, E, F, na)], L),
	fw(G, H, L, prepnp(A, B), M, N, O, P, Q, C, D, E, F, R).

fpm(E, F, G, H, I, J, K, A, B, C, D, na) :-
	register(fw(advp, M, N, O, P, Q, A, B, C, D, R), E, F, wy11, [G/fpm(H, I, J, K, A, B, C, D, na)], L),
	fw(E, F, L, advp, M, N, O, P, Q, A, B, C, D, R).

fpm(H, A, J, K, L, M, N, E, F, G, B, na) :-
	optional(O, [], A, I, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	register(fl(Q, R, S, T, E, F, G, D, U), H, I, lu1, [J/fpm(K, L, M, N, E, F, G, B, na)|O], P),
	fl(H, I, P, Q, R, S, T, E, F, G, D, U).

fpm(W2, B, Y2, Z2, A3, B3, X, A, Y, Z, A1, po) :-
	sequence_of(C3, [C, J1/fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na)|Q1], B, C, [[optional(przec(D, po), {}, {D= (-'|'+)}), fpt(K1, E/F, I, wym([], K), J, L, A, M, N, H, po), optional(przec(G, po), {}, {G= (+'|'-)})]^[sprawdz_fpt_noa, D/H/G/O]^[I]^[J]^[K], fpm(P, Q, R, L, A, M, N, O, po)^[P]^[Q]^[R], fno(dop, S, 3, wym([], T), V, L, pre, A, M, N, O, po)^[S]^[T]^[sprawdz_kl_nod, U/V], fw(W, _, _, _, _, post, A, M, ni, O, po)^[zroblistę_iter, [], W, P1], modpart(fno, A, M, ni, O, po)]^[oblzap_iter, X, L, L1]^[obldest_iter, Y, M, M1]^[oblink_iter, Z, N, N1]^[sprawdz_pk_iter, A1, O, O1]),
	goal(fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na), C, R1, J1),
	D1=wym(_, [_|_]),
	sprawdz_kl_noa(U, B1, K1),
	oblzap_iter(L1, E1, M2),
	obldest_iter(M1, G1, O2),
	oblink_iter(N1, H1, P2),
	sprawdz_pk_iter(O1, I1, Q2),
	wyjmijl(P1, D1, K2),
	sequence_of(Q1, [], R1, X2, [[optional(przec(S1, po), {}, {S1= (-'|'+)}), fpt(K1, E/F, V1, wym([], X1), W1, Y1, A, Z1, A2, U1, po), optional(przec(T1, po), {}, {T1= (+'|'-)})]^[sprawdz_fpt_noa, S1/U1/T1/B2]^[V1]^[W1]^[X1], fpm(C2, D2, E2, Y1, A, Z1, A2, B2, po)^[C2]^[D2]^[E2], fno(dop, F2, 3, wym([], G2), H2, Y1, pre, A, Z1, A2, B2, po)^[F2]^[G2]^[sprawdz_kl_nod, U/H2], fzd(I2, nk, _, _, _, J2, ni, B2, po)^[sprawdz_fzd_noz, E/F/U/N2, I2, _]^[J2], fw(L2, _, _, _, _, post, A, Z1, ni, B2, po)^[oblwym_iter, K2, L2, R2], modpart(fno, A, Z1, ni, B2, po)]^[oblzap_iter, M2, Y1, N2]^[obldest_iter, O2, Z1, T2]^[oblink_iter, P2, A2, U2]^[sprawdz_pk_iter, Q2, B2, V2]),
	R2=wym([], S2),
	resztawym(S2),
	register(fno(B1, E/F, C1, wym(E3, bw), U, N2, F1, A, T2, U2, V2, F3), W2, X2, nop2, [Y2/fpm(Z2, A3, B3, X, A, Y, Z, A1, po)|C3], D3),
	fno(W2, X2, D3, B1, E/F, C1, wym(E3, bw), U, N2, F1, A, T2, U2, V2, F3).

fpm(R, B, T, L, M, A, N, C, I, J, K, na) :-
	A\=mod,
	sequence_of(U, [], B, S, [fps(D, E, C, F, G, H, po)^[D]^[E], modpart(fpm, C, F, G, H, po)]^[obldest_iter, I, F, O]^[oblink_iter, J, G, P]^[sprawdz_pk_iter, K, H, Q]^[conajmniej1, 0, _, 1]),
	register(fpm(L, M, mod, N, C, O, P, Q, W), R, S, pm4, [T/fpm(L, M, A, N, C, I, J, K, na)|U], V),
	fpm(R, S, V, L, M, mod, N, C, O, P, Q, W).

fpm(G2, A, I2, J2, K2, L2, R, M2, S, T, U, po) :-
	sequence_of(N2, [B, C1/fpt(O, P, V, W, X, Y, N, Z, A1, B1, na)|I1], A, B, [fps(C, D, E, F, G, H, po)^[C]^[D]^[E], fpm(I, J, K, Q, L, F, G, H, po)^[I]^[J]^[K]^[L], fw(M, _, _, _, _, post, tak, F, G, H, po)^[zroblistę_iter, [], M, H1], modpart(fpt, N, F, G, H, po), modjaki(O, P, Q, F, G, H, po)]^[oblzap_iter, R, Q, D1]^[obldest_iter, S, F, E1]^[oblink_iter, T, G, F1]^[sprawdz_pk_iter, U, H, G1]),
	goal(fpt(O, P, V, W, X, Y, N, Z, A1, B1, na), B, J1, C1),
	W=wym(_, [_|_]),
	oblzap_iter(D1, Y, X1),
	obldest_iter(E1, Z, Y1),
	oblink_iter(F1, A1, Z1),
	sprawdz_pk_iter(G1, B1, A2),
	wyjmijl(H1, W, U1),
	sequence_of(I1, [], J1, H2, [fps(K1, L1, M1, N1, O1, P1, po)^[K1]^[L1]^[M1], fpm(Q1, R1, S1, W1, T1, N1, O1, P1, po)^[Q1]^[R1]^[S1]^[T1], fw(V1, _, _, _, _, post, tak, N1, O1, P1, po)^[oblwym_iter, U1, V1, B2], modpart(fpt, N, N1, O1, P1, po), modjaki(O, P, W1, N1, O1, P1, po)]^[oblzap_iter, X1, W1, C2]^[obldest_iter, Y1, N1, D2]^[oblink_iter, Z1, O1, E2]^[sprawdz_pk_iter, A2, P1, F2]),
	sprawdz_reszte(B2),
	register(fpt(O, P, V, wym(P2, bw), X, C2, N, D2, E2, F2, Q2), G2, H2, ptm2, [I2/fpm(J2, K2, L2, R, M2, S, T, U, po)|N2], O2),
	fpt(G2, H2, O2, O, P, V, wym(P2, bw), X, C2, N, D2, E2, F2, Q2).

fpm(N1, B, P1, Q1, R1, S1, T1, A, L, M, N, po) :-
	sequence_of(U1, [C, T/fps(O, P, A, Q, R, S, na)|X], B, C, [fpm(D, E, F, G, A, H, I, J, po)^[D]^[E]^[F]^[G], fps(K, F, A, H, I, J, po)^[K]^[F], modpart(fpt, A, H, I, J, po)]^[obldest_iter, L, H, U]^[oblink_iter, M, I, V]^[sprawdz_pk_iter, N, J, W]),
	goal(fps(O, P, A, Q, R, S, na), C, Y, T),
	P\=mod,
	obldest_iter(U, Q, H1),
	oblink_iter(V, R, I1),
	sprawdz_pk_iter(W, S, J1),
	sequence_of(X, [], Y, O1, [fpm(Z, A1, B1, C1, A, D1, E1, F1, po)^[Z]^[A1]^[B1]^[C1], fps(G1, B1, A, D1, E1, F1, po)^[G1]^[B1], modpart(fpt, A, D1, E1, F1, po)]^[obldest_iter, H1, D1, K1]^[oblink_iter, I1, E1, L1]^[sprawdz_pk_iter, J1, F1, M1]),
	register(fps(O, mod, A, K1, L1, M1, W1), N1, O1, psm2, [P1/fpm(Q1, R1, S1, T1, A, L, M, N, po)|U1], V1),
	fps(N1, O1, V1, O, mod, A, K1, L1, M1, W1).

fpmpt(G, H, I, A, B, J, K, C, D, E, F, na) :-
	register(fw(prepadjp(A, B), M, N, O, P, Q, C, D, E, F, R), G, H, wyp1, [I/fpmpt(A, B, J, K, C, D, E, F, na)], L),
	fw(G, H, L, prepadjp(A, B), M, N, O, P, Q, C, D, E, F, R).

fpmpt(E, F, G, H, pop, I, J, A, B, C, D, na) :-
	register(fl(L, M, N, O, A, B, C, D, P), E, F, lu14, [G/fpmpt(H, pop, I, J, A, B, C, D, na)], K),
	fl(E, F, K, L, M, N, O, A, B, C, D, P).

fno(H, I, J, mian, A, B, wym([], K), L, M, C, D, E, F, G, na) :-
	register(fw(subj, O, P, A, B, C, D, E, F, G, Q), H, I, wy3, [J/fno(mian, A, B, wym([], K), L, M, C, D, E, F, G, na)], N),
	fw(H, I, N, subj, O, P, A, B, C, D, E, F, G, Q).

fno(E, F, G, dop, H, I, wym([], J), K, L, pre, nie(A), B, C, D, na) :-
	register(fw(np(bier), N, O, P, Q, R, nie(A), B, C, D, S), E, F, wy4, [G/fno(dop, H, I, wym([], J), K, L, pre, nie(A), B, C, D, na)], M),
	fw(E, F, M, np(bier), N, O, P, Q, R, nie(A), B, C, D, S).

fno(D, E, F, bier, G, H, wym([], I), J, K, pre, tak, A, B, C, na) :-
	register(fw(np(bier), M, N, O, P, Q, tak, A, B, C, R), D, E, wy5, [F/fno(bier, G, H, wym([], I), J, K, pre, tak, A, B, C, na)], L),
	fw(D, E, L, np(bier), M, N, O, P, Q, tak, A, B, C, R).

fno(F, G, H, A, I, J, wym([], K), L, M, pre, B, C, D, E, na) :-
	różne(A, [bier, miej, wol]),
	register(fw(np(A), O, P, Q, R, S, B, C, D, E, T), F, G, wy6, [H/fno(A, I, J, wym([], K), L, M, pre, B, C, D, E, na)], N),
	fw(F, G, N, np(A), O, P, Q, R, S, B, C, D, E, T).

fno(J, C, L, A, M, N, wym([], O), B, P, pre, G, H, I, D, na) :-
	równe(A, [cel, bier, narz]),
	B\=przym,
	optional(Q, [], C, K, przec(E, po), {oblpk(F, [ (-'|'+), D, E])}, {F=D}),
	register(fl(S, T, U, V, G, H, I, F, W), J, K, lu2, [L/fno(A, M, N, wym([], O), B, P, pre, G, H, I, D, na)|Q], R),
	fl(J, K, R, S, T, U, V, G, H, I, F, W).

fno(G, B, I, wol, E, J, wym([], K), A, L, pre, M, neut, ni, D, na) :-
	A\=przym,
	optional(N, [], B, H, przec(C, po), {}, {C= (+'|'-)}),
	oblpk(F, [ (-'|'+), D, C]),
	register(fl(P, Q, E, 2, R, neut, ni, F, S), G, H, lu12o, [I/fno(wol, E, J, wym([], K), A, L, pre, M, neut, ni, D, na)|N], O),
	fl(G, H, O, P, Q, E, 2, R, neut, ni, F, S).

fno(G, B, I, wol, J, K, wym([], L), A, M, pre, N, neut, ni, D, na) :-
	A\=przym,
	optional(O, [], B, H, przec(C, po), {}, {C= (+'|'-)}),
	równe(E, [1, 3]),
	oblpk(F, [ (-'|'+), D, C]),
	register(fl(Q, R, S, E, T, neut, ni, F, U), G, H, lu13o, [I/fno(wol, J, K, wym([], L), A, M, pre, N, neut, ni, D, na)|O], P),
	fl(G, H, P, Q, R, S, E, T, neut, ni, F, U).

fno(N1, D, P1, C, G/H, I1, A, B, B1, J1, I, D1, E1, F1, na) :-
	A=wym(_, [_|_]),
	sprawdz_kl_noa(B, C, F),
	sequence_of(Q1, [], D, O1, [[optional(przec(E, po), {}, {E= (-'|'+)}), fpt(F, G/H, L, wym([], N), M, O, I, P, Q, K, po), optional(przec(J, po), {}, {J= (+'|'-)})]^[sprawdz_fpt_noa, E/K/J/R]^[L]^[M]^[N], fpm(S, T, U, O, I, P, Q, R, po)^[S]^[T]^[U], fno(dop, V, 3, wym([], X), W, O, pre, I, P, Q, R, po)^[V]^[W]^[X]^[sprawdz_kl_nod, B/W], fzd(Y, nk, _, _, _, Z, ni, R, po)^[sprawdz_fzd_noz, G/H/B/C1, Y, _]^[Z], fw(A1, _, _, _, _, post, I, P, ni, R, po)^[oblwym_iter, A, A1, G1], modpart(fno, I, P, ni, R, po)]^[oblzap_iter, B1, O, C1]^[obldest_iter, D1, P, K1]^[oblink_iter, E1, Q, L1]^[sprawdz_pk_iter, F1, R, M1]^[conajmniej1, 0, _, 1]),
	G1=wym([], H1),
	resztawym(H1),
	register(fno(C, G/H, I1, wym(S1, bw), B, C1, J1, I, K1, L1, M1, T1), N1, O1, noa1, [P1/fno(C, G/H, I1, A, B, B1, J1, I, D1, E1, F1, na)|Q1], R1),
	fno(N1, O1, R1, C, G/H, I1, wym(S1, bw), B, C1, J1, I, K1, L1, M1, T1).

fno(W2, B, Y2, dop, Z2, 3, wym([], A3), B3, X, pre, A, Y, Z, A1, po) :-
	sequence_of(C3, [C, J1/fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na)|Q1], B, C, [[optional(przec(D, po), {}, {D= (-'|'+)}), fpt(K1, E/F, I, wym([], K), J, L, A, M, N, H, po), optional(przec(G, po), {}, {G= (+'|'-)})]^[sprawdz_fpt_noa, D/H/G/O]^[I]^[J]^[K], fpm(P, Q, R, L, A, M, N, O, po)^[P]^[Q]^[R], fno(dop, S, 3, wym([], T), V, L, pre, A, M, N, O, po)^[S]^[T]^[sprawdz_kl_nod, U/V], fw(W, _, _, _, _, post, A, M, ni, O, po)^[zroblistę_iter, [], W, P1], modpart(fno, A, M, ni, O, po)]^[oblzap_iter, X, L, L1]^[obldest_iter, Y, M, M1]^[oblink_iter, Z, N, N1]^[sprawdz_pk_iter, A1, O, O1]),
	goal(fno(B1, E/F, C1, D1, U, E1, F1, A, G1, H1, I1, na), C, R1, J1),
	D1=wym(_, [_|_]),
	sprawdz_kl_noa(U, B1, K1),
	oblzap_iter(L1, E1, M2),
	obldest_iter(M1, G1, O2),
	oblink_iter(N1, H1, P2),
	sprawdz_pk_iter(O1, I1, Q2),
	wyjmijl(P1, D1, K2),
	sequence_of(Q1, [], R1, X2, [[optional(przec(S1, po), {}, {S1= (-'|'+)}), fpt(K1, E/F, V1, wym([], X1), W1, Y1, A, Z1, A2, U1, po), optional(przec(T1, po), {}, {T1= (+'|'-)})]^[sprawdz_fpt_noa, S1/U1/T1/B2]^[V1]^[W1]^[X1], fpm(C2, D2, E2, Y1, A, Z1, A2, B2, po)^[C2]^[D2]^[E2], fno(dop, F2, 3, wym([], G2), H2, Y1, pre, A, Z1, A2, B2, po)^[F2]^[G2]^[sprawdz_kl_nod, U/H2], fzd(I2, nk, _, _, _, J2, ni, B2, po)^[sprawdz_fzd_noz, E/F/U/N2, I2, _]^[J2], fw(L2, _, _, _, _, post, A, Z1, ni, B2, po)^[oblwym_iter, K2, L2, R2], modpart(fno, A, Z1, ni, B2, po)]^[oblzap_iter, M2, Y1, N2]^[obldest_iter, O2, Z1, T2]^[oblink_iter, P2, A2, U2]^[sprawdz_pk_iter, Q2, B2, V2]),
	R2=wym([], S2),
	resztawym(S2),
	register(fno(B1, E/F, C1, wym(E3, bw), U, N2, F1, A, T2, U2, V2, F3), W2, X2, nod2, [Y2/fno(dop, Z2, 3, wym([], A3), B3, X, pre, A, Y, Z, A1, po)|C3], D3),
	fno(W2, X2, D3, B1, E/F, C1, wym(E3, bw), U, N2, F1, A, T2, U2, V2, F3).

fno(P, E, R, C, I, J, A, B, K, L, D, M, N, G, na) :-
	A\=wym(_, [apo]),
	B\=przym,
	goal(fno(C, T, 3, U, F, V, pre, D, neut, ni, H, po), E, Q, S),
	C\=dop,
	F\=przym,
	oblpk(O, [G, H]),
	register(fno(C, I, J, wym(X, [apo]), B, K, L, D, M, N, O, Y), P, Q, noap, [R/fno(C, I, J, A, B, K, L, D, M, N, G, na), E, S/fno(C, T, 3, U, F, V, pre, D, neut, ni, H, po)], W),
	fno(P, Q, W, C, I, J, wym(X, [apo]), B, K, L, D, M, N, O, Y).

fno(S, B, U, C, L, M, V, A, N, O, D, P, Q, I, na) :-
	A\=przym,
	goal(przec(J, po), B, E, W),
	goal(fno(C, Y, 3, Z, F, A1, pre, D, neut, ni, K, po), E, G, X),
	F\=przym,
	optional(B1, [], G, T, przec(H, po), {}, {H= (+'|'-)}),
	oblpk(R, [I, J, K, H]),
	register(fno(C, L, M, wym(D1, [apo]), A, N, O, D, P, Q, R, E1), S, T, noapp, [U/fno(C, L, M, V, A, N, O, D, P, Q, I, na), B, W/przec(J, po), E, X/fno(C, Y, 3, Z, F, A1, pre, D, neut, ni, K, po)|B1], C1),
	fno(S, T, C1, C, L, M, wym(D1, [apo]), A, N, O, D, P, Q, R, E1).

fno(U, D, W, A, B/C, N, O, E, J, X, Q, F, H, L, po) :-
	goal(flicz(A, B/C, uzg, K, G, I, M, na), D, V, Y),
	różne(E, [uzg|nuzg]),
	obldest(R, F, G),
	oblink(S, H, I),
	oblzap(P, [J, K]),
	oblpk(T, [L, M]),
	register(fno(A, B/C, N, O, uzg, P, A1, Q, R, S, T, B1), U, V, nol5, [W/fno(A, B/C, N, O, E, J, X, Q, F, H, L, po), D, Y/flicz(A, B/C, uzg, K, G, I, M, na)], Z),
	fno(U, V, Z, A, B/C, N, O, uzg, P, A1, Q, R, S, T, B1).

fno(U, C, W, dop, A/B, N, O, E, J, X, Q, F, H, L, po) :-
	goal(flicz(D, A/B, nuzg, K, G, I, M, na), C, V, Y),
	różne(D, mian),
	różne(E, [uzg|nuzg]),
	obldest(R, F, G),
	oblink(S, H, I),
	oblzap(P, [J, K]),
	oblpk(T, [L, M]),
	register(fno(D, A/B, N, O, nuzg, P, A1, Q, R, S, T, B1), U, V, nol7, [W/fno(dop, A/B, N, O, E, J, X, Q, F, H, L, po), C, Y/flicz(D, A/B, nuzg, K, G, I, M, na)], Z),
	fno(U, V, Z, D, A/B, N, O, nuzg, P, A1, Q, R, S, T, B1).

fno(S, C, U, dop, A/B, V, M, D, I, W, O, E, G, K, po) :-
	goal(flicz(mian, A/B, nuzg, J, F, H, L, na), C, T, X),
	różne(D, [uzg|nuzg]),
	obldest(P, E, F),
	oblink(Q, G, H),
	oblzap(N, [I, J]),
	oblpk(R, [K, L]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, M, nuzg, N, Z, O, P, Q, R, A1), S, T, nol9, [U/fno(dop, A/B, V, M, D, I, W, O, E, G, K, po), C, X/flicz(mian, A/B, nuzg, J, F, H, L, na)], Y),
	fno(S, T, Y, mian, r(mn(n), nmo(np(n)))/poj, 3, M, nuzg, N, Z, O, P, Q, R, A1).

fno(F1, A, H1, C, M/N, O, wym([], I1), P, D, Q, E, G, D1, I, po) :-
	goal(przec(J, po), A, B, J1),
	goal(spójnik(rc, L, ni, na), B, F, K1),
	goal(fno(C, R/S, T, wym([], M1), U, D, V, E, H, ni, K, po), F, G1, L1),
	obldest_fno_iter(G, H, C1),
	oblpk(E1, [I, J, K]),
	oblparam_fno_koor(L, W/X/Y/A1/B1/Z, M/N/O/P/Q, R/S/T/U/V, []),
	register(fno(C, W/X, Y, Z, A1, D, B1, E, C1, D1, E1, O1), F1, G1, nor1, [H1/fno(C, M/N, O, wym([], I1), P, D, Q, E, G, D1, I, po), A, J1/przec(J, po), B, K1/spójnik(rc, L, ni, na), F, L1/fno(C, R/S, T, wym([], M1), U, D, V, E, H, ni, K, po)], N1),
	fno(F1, G1, N1, C, W/X, Y, Z, A1, D, B1, E, C1, D1, E1, O1).

fno(X, B, Z, E, O/P, Q, R, S, F, T, G, A, V, K, na) :-
	tylko_neut_pyt(A),
	goal(przec(L, po), B, C, A1),
	goal(spójnik(rc, D, ni, po), C, H, B1),
	member(D, [czyli, więc, mianowicie, raczej]),
	goal(fno(E, D1/E1, F1, wym([], G1), H1, F, I1, G, J, ni, M, po), H, I, C1),
	goal(przec(N, po), I, Y, J1),
	obldest_fno_iter(A, J, U),
	oblpk(W, [K, L, M, N]),
	register(fno(E, O/P, Q, R, S, F, T, G, U, V, W, L1), X, Y, nor3, [Z/fno(E, O/P, Q, R, S, F, T, G, A, V, K, na), B, A1/przec(L, po), C, B1/spójnik(rc, D, ni, po), H, C1/fno(E, D1/E1, F1, wym([], G1), H1, F, I1, G, J, ni, M, po), I, J1/przec(N, po)], K1),
	fno(X, Y, K1, E, O/P, Q, R, S, F, T, G, U, V, W, L1).

fno(R1, D, T1, A, C1/D1, E1, wym([], U1), F1, B, G1, C, I, P1, Z, po) :-
	sequence_of(V1, [E, Q/spójnik(szk, F, ni, na), P, Y/fno(A, R/S, T, wym([], U), V, B, W, C, X, ni, H, po)], D, E, [[spójnik(sz, F, ni, na), fno(A, K/N, L, wym([], O), M, B, pre, C, J, ni, G, po), przec(_, po)]^[trzy_na_listę, A1, [ (0 '|' 0), G, (+'|'wp)], [ (0 '|' 0), H]]^[obldest_fno_iter, I, J, B1]^[zroblistę_iter, [], K/L/M, H1]^[N]^[O]^[conajmniej1, 0, _, 1]]),
	goal(spójnik(szk, F, ni, na), E, P, Q),
	F\=przec,
	sprawdz_neg(F, C),
	goal(fno(A, R/S, T, wym([], U), V, B, W, C, X, ni, H, po), P, S1, Y),
	oblpk(Q1, [Z|A1]),
	obldest_fno_iter(B1, X, O1),
	oblparam_fno_koor(F, I1/J1/K1/M1/N1/L1, C1/D1/E1/F1/G1, R/S/T/V/W, H1),
	register(fno(A, I1/J1, K1, L1, M1, B, N1, C, O1, P1, Q1, X1), R1, S1, nos2, [T1/fno(A, C1/D1, E1, wym([], U1), F1, B, G1, C, I, P1, Z, po)|V1], W1),
	fno(R1, S1, W1, A, I1/J1, K1, L1, M1, B, N1, C, O1, P1, Q1, X1).

fno(T1, D, V1, A, F1/G1, H1, wym([], W1), I1, B, J1, C, H, R1, C1, po) :-
	sequence_of(X1, [E, Q/spójnik(szk, O, ni, na), P, B1/fno(A, U/V, W, wym([], X), Y, B, Z, C, A1, ni, G, po)], D, E, [[spójnik(sz, przec, ni, po), fno(A, J/M, K, wym([], N), L, B, pre, C, I, ni, F, po)]^[dwa_na_listę, D1, [ (+'|'wp), F], [T, G]]^[obldest_fno_iter, H, I, E1]^[zroblistę_iter, [], J/K/L, R]^[M]^[N]]),
	goal(spójnik(szk, O, ni, na), E, P, Q),
	(   O=przec
	->  length(R, S),
	    S>0,
	    T= (+'|'wp)
	;   T= (0 '|' 0)
	),
	sprawdz_neg(O, C),
	goal(fno(A, U/V, W, wym([], X), Y, B, Z, C, A1, ni, G, po), P, U1, B1),
	oblpk(S1, [C1|D1]),
	obldest_fno_iter(E1, A1, Q1),
	oblparam_fno_koor(O, K1/L1/M1/O1/P1/N1, F1/G1/H1/I1/J1, U/V/W/Y/Z, R),
	register(fno(A, K1/L1, M1, N1, O1, B, P1, C, Q1, R1, S1, Z1), T1, U1, nos3, [V1/fno(A, F1/G1, H1, wym([], W1), I1, B, J1, C, H, R1, C1, po)|X1], Y1),
	fno(T1, U1, Y1, A, K1/L1, M1, N1, O1, B, P1, C, Q1, R1, S1, Z1).

fno(K, B, M, A, N/O, P, wym([], Q), E, F, pre, G, H, I, D, po) :-
	goal(przyimek(C, A, na), B, L, R),
	równe(C, [naprzeciwko|temu]),
	oblpk(J, [D, (+'|'0)]),
	register(fpm(C, A, E, F, G, H, I, J, T), K, L, pm2, [M/fno(A, N/O, P, wym([], Q), E, F, pre, G, H, I, D, po), B, R/przyimek(C, A, na)], S),
	fpm(K, L, S, C, A, E, F, G, H, I, J, T).

terminal(A, B, C, morf(D, się, qub)) :-
	register(fw(sie, F, G, H, I, J, K, neut, ni, (0 '|' 0), L), A, B, wy7, [C/terminal(morf(D, się, qub))], E),
	fw(A, B, E, sie, F, G, H, I, J, K, neut, ni, (0 '|' 0), L).

terminal(A, B, C, morf(D, się, qub)) :-
	register(fw(subj, F, G, r(mn(n), nmo(np(n)))/poj, 3, H, I, neut, ni, (0 '|' 0), J), A, B, wy8, [C/terminal(morf(D, się, qub))], E),
	fw(A, B, E, subj, F, G, r(mn(n), nmo(np(n)))/poj, 3, H, I, neut, ni, (0 '|' 0), J).

terminal(D, E, F, morf(G, A, qub)) :-
	slowpart(A, B),
	member(C, B),
	register(modpart(C, I, neut, ni, (0 '|' 0), J), D, E, mp1, [F/terminal(morf(G, A, qub))], H),
	modpart(D, E, H, C, I, neut, ni, (0 '|' 0), J).

terminal(C, D, E, morf(F, A, qub)) :-
	member(B, [pyt, pz]),
	member(A, [czy, czyż, czyżby, azali, azaliż, li]),
	register(modpart(fin, H, B, ni, (0 '|' 0), I), C, D, mp2, [E/terminal(morf(F, A, qub))], G),
	modpart(C, D, G, fin, H, B, ni, (0 '|' 0), I).

terminal(G, D, I, morf(J, A, brev:B)) :-
	slowskr(A, _, B, E, qub),
	slowpart(A, C),
	member(F, C),
	optional(K, [], D, H, terminal(morf('.', _, interp)), {E\=kon}, {E\=nkon}),
	register(modpart(F, M, neut, ni, (0 '|' 0), N), G, H, mp3, [I/terminal(morf(J, A, brev:B))|K], L),
	modpart(G, H, L, F, M, neut, ni, (0 '|' 0), N).

terminal(E, B, G, morf(H, co, prep:A)) :-
	przypadki(A, bier),
	goal(terminal(morf(J, C, adv:sup)), B, F, I),
	member(C, [wysoko, mało]),
	member(D, [fno, flicz, fpm, fin]),
	register(modpart(D, L, neut, ni, (0 '|' 0), M), E, F, mp5, [G/terminal(morf(H, co, prep:A)), B, I/terminal(morf(J, C, adv:sup))], K),
	modpart(E, F, K, D, L, neut, ni, (0 '|' 0), M).

terminal(E, B, G, morf(H, co, prep:A)) :-
	przypadki(A, bier),
	goal(terminal(morf(J, C, adv:com)), B, F, I),
	member(C, [dużo]),
	member(D, [fin]),
	register(modpart(D, L, neut, ni, (0 '|' 0), M), E, F, mp6, [G/terminal(morf(H, co, prep:A)), B, I/terminal(morf(J, C, adv:com))], K),
	modpart(E, F, K, D, L, neut, ni, (0 '|' 0), M).

terminal(I, J, K, morf(L, D, subst:A:B:C)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	rekcja_nominalna(D, H),
	register(formarzecz(E, F/G, H, N), I, J, n_rz1, [K/terminal(morf(L, D, subst:A:B:C))], M),
	formarzecz(I, J, M, E, F/G, H, N).

terminal(I, J, K, morf(L, D, depr:A:B:C)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	rekcja_nominalna(D, H),
	register(formarzecz(E, F/G, H, N), I, J, n_rz2, [K/terminal(morf(L, D, depr:A:B:C))], M),
	formarzecz(I, J, M, E, F/G, H, N).

terminal(I, J, K, morf(L, D, ger:A:B:C:M:N)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	rekcja_gerundialna(D, H),
	register(formarzecz(E, F/G, H, P), I, J, n_rz3, [K/terminal(morf(L, D, ger:A:B:C:M:N))], O),
	formarzecz(I, J, O, E, F/G, H, P).

terminal(C, D, E, morf(F, G, siebie:A)) :-
	przypadki(A, B),
	register(formarzecz(B, I/J, wym(K, [[]]), L), C, D, n_rz4, [E/terminal(morf(F, G, siebie:A))], H),
	formarzecz(C, D, H, B, I/J, wym(K, [[]]), L).

terminal(O, E, Q, morf(R, D, subst:A:B:C)) :-
	liczba(A, H),
	przypadki(B, J),
	rodzaj(C, L),
	rekcja_nominalna(D, N),
	goal(terminal(morf(-, -, interp)), E, F, S),
	goal(terminal(morf(U, V, subst:G:I:K)), F, P, T),
	liczba(G, H),
	przypadki(I, J),
	rodzaj(K, M),
	L=M,
	register(formarzecz(J, L/H, N, X), O, P, n_rz5, [Q/terminal(morf(R, D, subst:A:B:C)), E, S/terminal(morf(-, -, interp)), F, T/terminal(morf(U, V, subst:G:I:K))], W),
	formarzecz(O, P, W, J, L/H, N, X).

terminal(L, F, N, morf(O, A, brev:B)) :-
	slowskr(A, _, B, G, subst:C:D:E),
	liczba(C, J),
	przypadki(D, H),
	rodzaj(E, I),
	rekcja_nominalna(A, K),
	optional(P, [], F, M, terminal(morf('.', _, interp)), {G\=kon}, {G\=nkon}),
	register(formarzecz(H, I/J, K, R), L, M, n_rz6, [N/terminal(morf(O, A, brev:B))|P], Q),
	formarzecz(L, M, Q, H, I/J, K, R).

terminal(G, D, I, morf(B, A, brev:C)) :-
	slowskr(A, B, C, E, ini),
	member(F, [mian, dop, cel, bier, narz, miej]),
	optional(J, [], D, H, terminal(morf('.', _, interp)), {E\=kon}, {E\=nkon}),
	register(formarzecz(F, L/poj, wym(M, bw), N), G, H, n_rz7, [I/terminal(morf(B, A, brev:C))|J], K),
	formarzecz(G, H, K, F, L/poj, wym(M, bw), N).

terminal(I, J, K, morf(L, M, ppron12:A:B:C:D)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	osoba(D, H),
	register(zaimos(E, F/G, H, O), I, J, n_zo1, [K/terminal(morf(L, M, ppron12:A:B:C:D))], N),
	zaimos(I, J, N, E, F/G, H, O).

terminal(I, J, K, morf(L, M, ppron12:A:B:C:D:N)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	osoba(D, H),
	register(zaimos(E, F/G, H, P), I, J, n_zo2, [K/terminal(morf(L, M, ppron12:A:B:C:D:N))], O),
	zaimos(I, J, O, E, F/G, H, P).

terminal(I, J, K, morf(L, M, ppron3:A:B:C:D:N)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	osoba(D, H),
	register(zaimos(E, F/G, H, P), I, J, n_zo3, [K/terminal(morf(L, M, ppron3:A:B:C:D:N))], O),
	zaimos(I, J, O, E, F/G, H, P).

terminal(B, C, D, morf(E, A, conj)) :-
	równe(A, [nie, tak, zarówno]),
	register(spójnik(rl, A, ni, G), B, C, sr1, [D/terminal(morf(E, A, conj))], F),
	spójnik(B, C, F, rl, A, ni, G).

terminal(B, A, D, morf(E, nie, conj)) :-
	goal(terminal(morf(G, tylko, conj)), A, C, F),
	register(spójnik(rl, nietylko, ni, I), B, C, sr2, [D/terminal(morf(E, nie, conj)), A, F/terminal(morf(G, tylko, conj))], H),
	spójnik(B, C, H, rl, nietylko, ni, I).

terminal(B, C, D, morf(E, A, conj)) :-
	równe(A, [ale, lecz]),
	register(spójnik(rp, nie, ni, G), B, C, sr3, [D/terminal(morf(E, A, conj))], F),
	spójnik(B, C, F, rp, nie, ni, G).

terminal(D, B, F, morf(G, A, conj)) :-
	równe(A, [ale, lecz]),
	goal(terminal(morf(I, C, qub)), B, E, H),
	równe(C, [i, również, także]),
	register(spójnik(rp, nietylko, ni, K), D, E, sr4, [F/terminal(morf(G, A, conj)), B, H/terminal(morf(I, C, qub))], J),
	spójnik(D, E, J, rp, nietylko, ni, K).

terminal(B, C, D, morf(E, jak, conj)) :-
	równe(A, [tak, zarówno]),
	register(spójnik(rp, A, ni, G), B, C, sr5, [D/terminal(morf(E, jak, conj))], F),
	spójnik(B, C, F, rp, A, ni, G).

terminal(D, A, F, morf(G, jak, conj)) :-
	goal(terminal(morf(I, B, qub)), A, E, H),
	równe(C, [tak, zarówno]),
	równe(B, [i, też]),
	register(spójnik(rp, C, ni, K), D, E, sr6, [F/terminal(morf(G, jak, conj)), A, H/terminal(morf(I, B, qub))], J),
	spójnik(D, E, J, rp, C, ni, K).

terminal(B, C, D, morf(E, A, conj)) :-
	równe(A, [a, ale, lecz]),
	register(spójnik(rc, a, ni, G), B, C, sr10, [D/terminal(morf(E, A, conj))], F),
	spójnik(B, C, F, rc, a, ni, G).

terminal(D, B, F, morf(G, A, conj)) :-
	równe(A, [a, ale, lecz]),
	goal(terminal(morf(I, C, qub)), B, E, H),
	równe(C, [i, nawet, również, także]),
	register(spójnik(rc, alei, ni, K), D, E, sr11, [F/terminal(morf(G, A, conj)), B, H/terminal(morf(I, C, qub))], J),
	spójnik(D, E, J, rc, alei, ni, K).

terminal(A, B, C, morf(D, natomiast, conj)) :-
	register(spójnik(rc, natomiast, ni, F), A, B, sr12, [C/terminal(morf(D, natomiast, conj))], E),
	spójnik(A, B, E, rc, natomiast, ni, F).

terminal(C, B, E, morf(F, A, conj)) :-
	równe(A, [a, ale]),
	goal(terminal(morf(H, nie, qub)), B, D, G),
	register(spójnik(rc, nie, ni, J), C, D, sr13, [E/terminal(morf(F, A, conj)), B, G/terminal(morf(H, nie, qub))], I),
	spójnik(C, D, I, rc, nie, ni, J).

terminal(B, A, D, morf(E, nie, qub)) :-
	goal(terminal(morf(G, zaś, conj)), A, C, F),
	register(spójnik(rc, nie, ni, I), B, C, sr14, [D/terminal(morf(E, nie, qub)), A, F/terminal(morf(G, zaś, conj))], H),
	spójnik(B, C, H, rc, nie, ni, I).

terminal(B, C, D, morf(E, A, conj)) :-
	member(A, [czyli, mianowicie]),
	register(spójnik(rc, A, ni, G), B, C, sr50, [D/terminal(morf(E, A, conj))], F),
	spójnik(B, C, F, rc, A, ni, G).

terminal(B, A, D, morf(E, a, conj)) :-
	goal(terminal(morf(G, mianowicie, conj)), A, C, F),
	register(spójnik(rc, mianowicie, ni, I), B, C, sr51, [D/terminal(morf(E, a, conj)), A, F/terminal(morf(G, mianowicie, conj))], H),
	spójnik(B, C, H, rc, mianowicie, ni, I).

terminal(B, A, D, morf(E, a, conj)) :-
	goal(terminal(morf(G, raczej, qub)), A, C, F),
	register(spójnik(rc, raczej, ni, I), B, C, sr52, [D/terminal(morf(E, a, conj)), A, F/terminal(morf(G, raczej, qub))], H),
	spójnik(B, C, H, rc, raczej, ni, I).

terminal(B, C, D, morf(E, A, conj)) :-
	równe(A, [natomiast, zaś]),
	register(spójnik(i(r, A), A, ni, G), B, C, sr20, [D/terminal(morf(E, A, conj))], F),
	spójnik(B, C, F, i(r, A), A, ni, G).

terminal(C, D, E, morf(F, A, conj)) :-
	równe(A, [albo, bądź, i, lub]),
	równe(B, [sz, szk]),
	register(spójnik(B, A, ni, H), C, D, sr21, [E/terminal(morf(F, A, conj))], G),
	spójnik(C, D, G, B, A, ni, H).

terminal(C, D, E, morf(F, A, conj)) :-
	równe(B, [sz, szk]),
	równe(A, [ani, ni]),
	register(spójnik(B, ani, ni, H), C, D, sr22, [E/terminal(morf(F, A, conj))], G),
	spójnik(C, D, G, B, ani, ni, H).

terminal(C, D, E, morf(F, A, interp)) :-
	member(A, [',', ;]),
	równe(B, [sz, szk]),
	register(spójnik(B, przec, ni, H), C, D, sr23, [E/terminal(morf(F, A, interp))], G),
	spójnik(C, D, G, B, przec, ni, H).

terminal(D, B, F, morf(G, A, conj)) :-
	równe(A, [albo, bądź, lub]),
	goal(terminal(morf(I, C, qub)), B, E, H),
	równe(C, [nawet, też]),
	register(spójnik(szk, A, ni, K), D, E, sr24, [F/terminal(morf(G, A, conj)), B, H/terminal(morf(I, C, qub))], J),
	spójnik(D, E, J, szk, A, ni, K).

terminal(D, B, F, morf(G, A, conj)) :-
	równe(A, [ani, ni]),
	goal(terminal(morf(I, C, qub)), B, E, H),
	równe(C, [nawet, też]),
	register(spójnik(szk, ani, ni, K), D, E, sr25, [F/terminal(morf(G, A, conj)), B, H/terminal(morf(I, C, qub))], J),
	spójnik(D, E, J, szk, ani, ni, K).

terminal(C, A, E, morf(F, i, conj)) :-
	goal(terminal(morf(H, B, qub)), A, D, G),
	równe(B, [nawet, także]),
	register(spójnik(szk, i, ni, J), C, D, sr26, [E/terminal(morf(F, i, conj)), A, G/terminal(morf(H, B, qub))], I),
	spójnik(C, D, I, szk, i, ni, J).

terminal(A, B, C, morf(D, oraz, conj)) :-
	register(spójnik(szk, i, ni, F), A, B, sr27, [C/terminal(morf(D, oraz, conj))], E),
	spójnik(A, B, E, szk, i, ni, F).

terminal(A, B, C, morf(D, czy, conj)) :-
	register(spójnik(szk, czy, ni, F), A, B, sr49, [C/terminal(morf(D, czy, conj))], E),
	spójnik(A, B, E, szk, czy, ni, F).

terminal(C, D, E, morf(F, A, conj)) :-
	równe(B, [pl, pp]),
	równe(A, [dopóty, póty]),
	register(spójnik(B, dopóki, ni, H), C, D, spoj22, [E/terminal(morf(F, A, conj))], G),
	spójnik(C, D, G, B, dopóki, ni, H).

terminal(C, D, E, morf(F, A, adv)) :-
	równe(B, [pl, pp]),
	równe(A, [wówczas, wtedy]),
	register(spójnik(B, gdy, ni, H), C, D, spoj23, [E/terminal(morf(F, A, adv))], G),
	spójnik(C, D, G, B, gdy, ni, H).

terminal(B, C, D, morf(E, jednak, conj)) :-
	równe(A, [chociaż, choćby]),
	register(spójnik(pp, A, ni, G), B, C, spoj24, [D/terminal(morf(E, jednak, conj))], F),
	spójnik(B, C, F, pp, A, ni, G).

terminal(C, A, E, morf(F, to, conj)) :-
	goal(terminal(morf(H, jednak, conj)), A, D, G),
	równe(B, [chociaż, choćby]),
	register(spójnik(pp, B, ni, J), C, D, spoj25, [E/terminal(morf(F, to, conj)), A, G/terminal(morf(H, jednak, conj))], I),
	spójnik(C, D, I, pp, B, ni, J).

terminal(B, C, D, morf(E, to, conj)) :-
	równe(A, [chociaż, choćby, gdyby, jeśli]),
	register(spójnik(pp, A, ni, G), B, C, spoj26, [D/terminal(morf(E, to, conj))], F),
	spójnik(B, C, F, pp, A, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [albowiem, bo, gdyż]),
	register(spójnik(pc, bo, ni, G), B, C, spoj27, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, pc, bo, ni, G).

terminal(C, D, E, morf(F, A, conj)) :-
	równe(B, [pc, i(p, więc)]),
	równe(A, [przeto, więc, zatem]),
	register(spójnik(B, więc, ni, H), C, D, spoj28, [E/terminal(morf(F, A, conj))], G),
	spójnik(C, D, G, B, więc, ni, H).

terminal(A, B, C, morf(D, toteż, conj)) :-
	register(spójnik(pc, więc, ni, F), A, B, spoj29, [C/terminal(morf(D, toteż, conj))], E),
	spójnik(A, B, E, pc, więc, ni, F).

terminal(C, A, E, morf(F, a, conj)) :-
	goal(terminal(morf(H, B, conj)), A, D, G),
	równe(B, [przeto, więc, zatem]),
	register(spójnik(rc, więc, ni, J), C, D, spoj48, [E/terminal(morf(F, a, conj)), A, G/terminal(morf(H, B, conj))], I),
	spójnik(C, D, I, rc, więc, ni, J).

terminal(A, B, C, morf(D, bowiem, comp)) :-
	register(spójnik(i(p, bowiem), bowiem, ni, F), A, B, spoj30, [C/terminal(morf(D, bowiem, comp))], E),
	spójnik(A, B, E, i(p, bowiem), bowiem, ni, F).

terminal(B, C, D, morf(E, aż, comp)) :-
	równe(A, [aż1, aż2]),
	register(spójnik(po, A, ni, G), B, C, spoj31, [D/terminal(morf(E, aż, comp))], F),
	spójnik(B, C, F, po, A, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [czy, jak, jakby, jakoby]),
	register(spójnik(po, A, ni, G), B, C, spoj32, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, A, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [chociaż, choć]),
	register(spójnik(po, chociaż, ni, G), B, C, spoj33, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, chociaż, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [chociażby, choćby]),
	register(spójnik(po, choćby, ni, G), B, C, spoj35, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, choćby, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [dopóki, póki]),
	register(spójnik(po, dopóki, ni, G), B, C, spoj36, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, dopóki, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [gdy, kiedy]),
	register(spójnik(po, gdy, ni, G), B, C, spoj37, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, gdy, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [gdyby, jeśliby, jeżeliby]),
	register(spójnik(po, gdyby, ni, G), B, C, spoj38, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, gdyby, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [jeśli, jeżeli]),
	register(spójnik(po, jeśli, ni, G), B, C, spoj39, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, jeśli, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [ponieważ, skoro]),
	register(spójnik(po, ponieważ, ni, G), B, C, spoj41, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, ponieważ, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [nim, zanim]),
	register(spójnik(po, zanim, ni, G), B, C, spoj42, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, zanim, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [iż, że]),
	register(spójnik(po, że, ni, G), B, C, spoj43, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, że, ni, G).

terminal(B, C, D, morf(E, A, comp)) :-
	równe(A, [aby, ażeby, by, iżby, żeby]),
	register(spójnik(po, żeby, ni, G), B, C, spoj44, [D/terminal(morf(E, A, comp))], F),
	spójnik(B, C, F, po, żeby, ni, G).

terminal(H, I, J, morf(K, D, psubst:A:B:C)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	register(zaimrzecz(D, E, F/G, M), H, I, jel5, [J/terminal(morf(K, D, psubst:A:B:C))], L),
	zaimrzecz(H, I, L, D, E, F/G, M).

terminal(H, I, J, morf(K, D, padj:A:B:C:pos)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	register(zaimprzym(D, E, F/G, M), H, I, jel6, [J/terminal(morf(K, D, padj:A:B:C:pos))], L),
	zaimprzym(H, I, L, D, E, F/G, M).

terminal(K, L, M, morf(N, E, adj:A:B:C:D)) :-
	liczba(A, H),
	przypadki(B, F),
	rodzaj(C, G),
	stopien(D, I),
	rekcja_przymiotnikowa(E, J),
	register(formaprzym(F, G/H, I, J, P), K, L, n_pt1, [M/terminal(morf(N, E, adj:A:B:C:D))], O),
	formaprzym(K, L, O, F, G/H, I, J, P).

terminal(H, A, J, morf(K, L, adja)) :-
	goal(terminal(morf(-, -, interp)), A, B, M),
	goal(formaprzym(C, D/E, F, G, na), B, I, N),
	register(formaprzym(C, D/E, F, G, P), H, I, n_pt2, [J/terminal(morf(K, L, adja)), A, M/terminal(morf(-, -, interp)), B, N/formaprzym(C, D/E, F, G, na)], O),
	formaprzym(H, I, O, C, D/E, F, G, P).

terminal(A, B, C, morf(D, E, adjp)) :-
	register(formaprzym(pop, G/H, row, wym(I, bw), J), A, B, n_pt5, [C/terminal(morf(D, E, adjp))], F),
	formaprzym(A, B, F, pop, G/H, row, wym(I, bw), J).

terminal(I, J, K, morf(L, D, ppas:A:B:C:M)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	rekcja_ppas(D, H),
	register(formaprzym(E, F/G, row, H, O), I, J, n_pt3, [K/terminal(morf(L, D, ppas:A:B:C:M))], N),
	formaprzym(I, J, N, E, F/G, row, H, O).

terminal(I, J, K, morf(L, D, pact:A:B:C:M)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	rekcja_pact(D, H),
	register(formaprzym(E, F/G, row, H, O), I, J, n_pt4, [K/terminal(morf(L, D, pact:A:B:C:M))], N),
	formaprzym(I, J, N, E, F/G, row, H, O).

terminal(D, E, F, morf(G, A, adjc)) :-
	rodzaj([m1, m2|m3], B),
	rekcja_przymiotnikowa(A, C),
	register(formaprzym(mian, B/poj, row, C, I), D, E, n_pt5, [F/terminal(morf(G, A, adjc))], H),
	formaprzym(D, E, H, mian, B/poj, row, C, I).

terminal(M, A, O, morf(B, G, adj:C:D:E:F)) :-
	goal(terminal(morf('.', Q, interp)), A, N, P),
	same_cyfry(B),
	liczba(C, J),
	przypadki(D, H),
	rodzaj(E, I),
	stopien(F, K),
	rekcja_przymiotnikowa(G, L),
	register(formaprzym(H, I/J, K, L, S), M, N, n_pt6, [O/terminal(morf(B, G, adj:C:D:E:F)), A, P/terminal(morf('.', Q, interp))], R),
	formaprzym(M, N, R, H, I/J, K, L, S).

terminal(O, A, Q, morf(C, I, adj:E:F:G:H)) :-
	goal(terminal(morf('.', S, interp)), A, B, R),
	goal(terminal(morf(D, U, num:pl:nom:f:V)), B, P, T),
	same_cyfry(C),
	same_cyfry(D),
	liczba(E, L),
	przypadki(F, J),
	rodzaj(G, K),
	stopien(H, M),
	rekcja_przymiotnikowa(I, N),
	register(formaprzym(J, K/L, M, N, X), O, P, n_pt6, [Q/terminal(morf(C, I, adj:E:F:G:H)), A, R/terminal(morf('.', S, interp)), B, T/terminal(morf(D, U, num:pl:nom:f:V))], W),
	formaprzym(O, P, W, J, K/L, M, N, X).

terminal(I, J, K, morf(L, M, num:A:B:C:D)) :-
	liczba(A, G),
	przypadki(B, E),
	rodzaj(C, F),
	akomodacyjnosc(D, H),
	register(formalicz(E, F/G, H, O), I, J, n_li, [K/terminal(morf(L, M, num:A:B:C:D))], N),
	formalicz(I, J, N, E, F/G, H, O).

terminal(J, K, L, morf(M, E, fin:D:C:A)) :-
	aspekt(A, B),
	czas(fin, B, F),
	osoba(C, H),
	liczba(D, G),
	rekcja_finitywna(E, I),
	register(formaczas(os, B, F, ozn, O/G, H, I, P), J, K, n_cz4, [L/terminal(morf(M, E, fin:D:C:A))], N),
	formaczas(J, K, N, os, B, F, ozn, O/G, H, I, P).

terminal(F, G, H, morf(I, być, bedzie:B:A:imperf)) :-
	osoba(A, D),
	liczba(B, C),
	rekcja_finitywna(być, E),
	register(formaczas(os, nd, przy, ozn, K/C, D, E, L), F, G, n_cz5, [H/terminal(morf(I, być, bedzie:B:A:imperf))], J),
	formaczas(F, G, J, os, nd, przy, ozn, K/C, D, E, L).

terminal(D, E, F, morf(G, B, inf:A)) :-
	aspekt(A, nd),
	rekcja_finitywna(B, C),
	register(przyzlo(I, J, C, K), D, E, n_czp1, [F/terminal(morf(G, B, inf:A))], H),
	przyzlo(D, E, H, I, J, C, K).

terminal(I, J, K, morf(L, E, praet:C:D:A)) :-
	asagl(A, B, nagl),
	aspekt(B, nd),
	liczba(C, G),
	rodzaj(D, F),
	rekcja_finitywna(E, H),
	register(przyzlo(N, F/G, H, O), I, J, n_czp2, [K/terminal(morf(L, E, praet:C:D:A))], M),
	przyzlo(I, J, M, N, F/G, H, O).

terminal(H, D, J, morf(K, być, bedzie:B:A:imperf)) :-
	osoba(A, F),
	liczba(B, C),
	goal(przyzlo(M, E/C, G, na), D, I, L),
	register(formaczas(os, nd, przy, ozn, E/C, F, G, O), H, I, n_cz6, [J/terminal(morf(K, być, bedzie:B:A:imperf)), D, L/przyzlo(M, E/C, G, na)], N),
	formaczas(H, I, N, os, nd, przy, ozn, E/C, F, G, O).

terminal(I, A, K, morf(L, być, bedzie:C:B:imperf)) :-
	goal(terminal(morf(N, się, qub)), A, E, M),
	osoba(B, G),
	liczba(C, D),
	goal(przyzlo(s, F/D, H, na), E, J, O),
	register(formaczas1(n, os, nd, przy, ozn, F/D, G, H, Q), I, J, n_cz8, [K/terminal(morf(L, być, bedzie:C:B:imperf)), A, M/terminal(morf(N, się, qub)), E, O/przyzlo(s, F/D, H, na)], P),
	formaczas1(I, J, P, n, os, nd, przy, ozn, F/D, G, H, Q).

terminal(J, K, L, morf(M, E, praet:C:D:A)) :-
	asagl(A, B, nagl),
	aspekt(B, F),
	liczba(C, H),
	rodzaj(D, G),
	rekcja_finitywna(E, I),
	register(formaczas(os, F, prze, ozn, G/H, 3, I, O), J, K, n_cz10, [L/terminal(morf(M, E, praet:C:D:A))], N),
	formaczas(J, K, N, os, F, prze, ozn, G/H, 3, I, O).

terminal(M, F, O, morf(P, E, praet:C:D:A)) :-
	asagl(A, B, agl),
	aspekt(B, H),
	liczba(C, J),
	rodzaj(D, I),
	rekcja_finitywna(E, L),
	goal(terminal(morf(R, być, aglt:C:G:S:T)), F, N, Q),
	osoba(G, K),
	register(formaczas(os, H, prze, ozn, I/J, K, L, V), M, N, n_cz11, [O/terminal(morf(P, E, praet:C:D:A)), F, Q/terminal(morf(R, być, aglt:C:G:S:T))], U),
	formaczas(M, N, U, os, H, prze, ozn, I/J, K, L, V).

terminal(A, B, C, morf(D, by, qub)) :-
	register(condaglt(F, 3, G), A, B, n_cza1, [C/terminal(morf(D, by, qub))], E),
	condaglt(A, B, E, F, 3, G).

terminal(F, A, H, morf(I, by, qub)) :-
	goal(terminal(morf(K, być, aglt:B:C:L:M)), A, G, J),
	liczba(B, D),
	osoba(C, E),
	register(condaglt(D, E, O), F, G, n_cza2, [H/terminal(morf(I, by, qub)), A, J/terminal(morf(K, być, aglt:B:C:L:M))], N),
	condaglt(F, G, N, D, E, O).

terminal(L, G, N, morf(O, E, praet:C:D:A)) :-
	asagl(A, B, nagl),
	aspekt(B, H),
	liczba(C, F),
	rodzaj(D, I),
	rekcja_finitywna(E, K),
	goal(condaglt(F, J, na), G, M, P),
	register(formaczas(os, H, R, war, I/F, J, K, S), L, M, n_cz12, [N/terminal(morf(O, E, praet:C:D:A)), G, P/condaglt(F, J, na)], Q),
	formaczas(L, M, Q, os, H, R, war, I/F, J, K, S).

terminal(N, A, P, morf(Q, F, praet:D:E:B)) :-
	goal(terminal(morf(S, się, qub)), A, I, R),
	asagl(B, C, nagl),
	aspekt(C, J),
	liczba(D, H),
	rodzaj(E, K),
	rekcja_finitywna(F, G),
	wyjmijwymaganie(sie, G, M),
	goal(condaglt(H, L, na), I, O, T),
	register(formaczas1(n, os, J, V, war, K/H, L, M, W), N, O, n_cz14, [P/terminal(morf(Q, F, praet:D:E:B)), A, R/terminal(morf(S, się, qub)), I, T/condaglt(H, L, na)], U),
	formaczas1(N, O, U, n, os, J, V, war, K/H, L, M, W).

terminal(M, A, O, morf(P, być, praet:B:C:imperf)) :-
	goal(condaglt(G, K, na), A, D, Q),
	goal(terminal(morf(S, H, praet:B:C:E)), D, N, R),
	asagl(E, F, nagl),
	aspekt(F, I),
	liczba(B, G),
	rodzaj(C, J),
	rekcja_finitywna(H, L),
	register(formaczas(os, I, prze, war, J/G, K, L, U), M, N, n_cz16, [O/terminal(morf(P, być, praet:B:C:imperf)), A, Q/condaglt(G, K, na), D, R/terminal(morf(S, H, praet:B:C:E))], T),
	formaczas(M, N, T, os, I, prze, war, J/G, K, L, U).

terminal(I, J, K, morf(L, D, impt:C:B:A)) :-
	aspekt(A, E),
	osoba(B, G),
	liczba(C, F),
	rekcja_finitywna(D, H),
	register(formaczas(os, E, przy, roz, N/F, G, H, O), I, J, n_cz16, [K/terminal(morf(L, D, impt:C:B:A))], M),
	formaczas(I, J, M, os, E, przy, roz, N/F, G, H, O).

terminal(K, B, M, morf(N, A, qub)) :-
	member(A, [niech, niechaj, niechże, niechajże]),
	goal(terminal(morf(P, F, fin:C:D:E)), B, L, O),
	(   C=sg,
	    D\=sec
	;   C=pl,
	    D=ter
	),
	aspekt(E, G),
	osoba(D, I),
	liczba(C, H),
	rekcja_finitywna(F, J),
	register(formaczas(os, G, przy, roz, R/H, I, J, S), K, L, n_cz17, [M/terminal(morf(N, A, qub)), B, O/terminal(morf(P, F, fin:C:D:E))], Q),
	formaczas(K, L, Q, os, G, przy, roz, R/H, I, J, S).

terminal(M, B, O, morf(P, A, qub)) :-
	member(A, [niech, niechaj, niechże, niechajże]),
	goal(terminal(morf(R, się, qub)), B, C, Q),
	goal(terminal(morf(T, G, fin:D:E:F)), C, N, S),
	(   D=sg,
	    E\=sec
	;   D=pl,
	    E=ter
	),
	aspekt(F, I),
	osoba(E, K),
	liczba(D, J),
	rekcja_finitywna(G, H),
	wyjmijwymaganie(sie, H, L),
	register(formaczas1(n, os, I, przy, roz, V/J, K, L, W), M, N, n_cz18, [O/terminal(morf(P, A, qub)), B, Q/terminal(morf(R, się, qub)), C, S/terminal(morf(T, G, fin:D:E:F))], U),
	formaczas1(M, N, U, n, os, I, przy, roz, V/J, K, L, W).

terminal(E, F, G, morf(H, B, imps:A)) :-
	aspekt(A, C),
	rekcja_niefinitywna(B, D),
	register(formaczas(bos, C, prze, ozn, J, K, D, L), E, F, n_cz19, [G/terminal(morf(H, B, imps:A))], I),
	formaczas(E, F, I, bos, C, prze, ozn, J, K, D, L).

terminal(F, A, H, morf(I, C, imps:B)) :-
	goal(terminal(morf(K, by, qub)), A, G, J),
	aspekt(B, D),
	rekcja_niefinitywna(C, E),
	register(formaczas(bos, D, M, war, N, O, E, P), F, G, n_cz20, [H/terminal(morf(I, C, imps:B)), A, J/terminal(morf(K, by, qub))], L),
	formaczas(F, G, L, bos, D, M, war, N, O, E, P).

terminal(F, A, H, morf(I, by, qub)) :-
	goal(terminal(morf(K, C, imps:B)), A, G, J),
	aspekt(B, D),
	rekcja_niefinitywna(C, E),
	register(formaczas(bos, D, M, war, N, O, E, P), F, G, n_cz21, [H/terminal(morf(I, by, qub)), A, J/terminal(morf(K, C, imps:B))], L),
	formaczas(F, G, L, bos, D, M, war, N, O, E, P).

terminal(H, A, J, morf(K, D, imps:C)) :-
	goal(terminal(morf(M, się, qub)), A, B, L),
	goal(terminal(morf(by, by, qub)), B, I, N),
	aspekt(C, F),
	rekcja_niefinitywna(D, E),
	wyjmijwymaganie(sie, E, G),
	register(formaczas1(n, bos, F, P, war, Q, R, G, S), H, I, n_cz22, [J/terminal(morf(K, D, imps:C)), A, L/terminal(morf(M, się, qub)), B, N/terminal(morf(by, by, qub))], O),
	formaczas1(H, I, O, n, bos, F, P, war, Q, R, G, S).

terminal(H, A, J, morf(K, by, qub)) :-
	goal(terminal(morf(M, się, qub)), A, B, L),
	goal(terminal(morf(O, D, imps:C)), B, I, N),
	aspekt(C, F),
	fail,
	rekcja_niefinitywna(D, E),
	wyjmijwymaganie(sie, E, G),
	register(formaczas1(n, bos, F, Q, war, R, S, G, T), H, I, n_cz23, [J/terminal(morf(K, by, qub)), A, L/terminal(morf(M, się, qub)), B, N/terminal(morf(O, D, imps:C))], P),
	formaczas1(H, I, P, n, bos, F, Q, war, R, S, G, T).

terminal(E, F, G, morf(H, B, inf:A)) :-
	aspekt(A, C),
	rekcja_finitywna(B, D),
	register(formaczas(bok, C, J, K, L, M, D, N), E, F, n_cz24, [G/terminal(morf(H, B, inf:A))], I),
	formaczas(E, F, I, bok, C, J, K, L, M, D, N).

terminal(E, F, G, morf(H, B, pant:A)) :-
	aspekt(A, C),
	rekcja_niefinitywna(B, D),
	register(formaczas(psu, C, J, K, L, M, D, N), E, F, n_cz25, [G/terminal(morf(H, B, pant:A))], I),
	formaczas(E, F, I, psu, C, J, K, L, M, D, N).

terminal(E, F, G, morf(H, B, pcon:A)) :-
	aspekt(A, C),
	rekcja_niefinitywna(B, D),
	register(formaczas(psw, C, J, K, L, M, D, N), E, F, n_cz26, [G/terminal(morf(H, B, pcon:A))], I),
	formaczas(E, F, I, psw, C, J, K, L, M, D, N).

terminal(C, D, E, morf(F, A, pred)) :-
	rekcja_finitywna(A, B),
	register(formaczas(os, nd, ter, ozn, H, I, B, J), C, D, n_cz27, [E/terminal(morf(F, A, pred))], G),
	formaczas(C, D, G, os, nd, ter, ozn, H, I, B, J).

terminal(D, A, F, morf(będzie, być, bedzie:sg:ter:imperf)) :-
	goal(terminal(morf(H, B, pred)), A, E, G),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, przy, ozn, J, K, C, L), D, E, n_cz28, [F/terminal(morf(będzie, być, bedzie:sg:ter:imperf)), A, G/terminal(morf(H, B, pred))], I),
	formaczas(D, E, I, os, nd, przy, ozn, J, K, C, L).

terminal(D, A, F, morf(G, B, pred)) :-
	goal(terminal(morf(będzie, być, bedzie:sg:ter:imperf)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, przy, ozn, J, K, C, L), D, E, n_cz29, [F/terminal(morf(G, B, pred)), A, H/terminal(morf(będzie, być, bedzie:sg:ter:imperf))], I),
	formaczas(D, E, I, os, nd, przy, ozn, J, K, C, L).

terminal(D, A, F, morf(było, być, praet:sg:G:imperf)) :-
	goal(terminal(morf(I, B, pred)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, prze, ozn, K, L, C, M), D, E, n_cz30, [F/terminal(morf(było, być, praet:sg:G:imperf)), A, H/terminal(morf(I, B, pred))], J),
	formaczas(D, E, J, os, nd, prze, ozn, K, L, C, M).

terminal(D, A, F, morf(G, B, pred)) :-
	goal(terminal(morf(było, być, praet:sg:I:imperf)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, prze, ozn, K, L, C, M), D, E, n_cz31, [F/terminal(morf(G, B, pred)), A, H/terminal(morf(było, być, praet:sg:I:imperf))], J),
	formaczas(D, E, J, os, nd, prze, ozn, K, L, C, M).

terminal(D, A, F, morf(G, B, pred)) :-
	goal(terminal(morf(I, by, qub)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, K, war, L, M, C, N), D, E, n_cz32, [F/terminal(morf(G, B, pred)), A, H/terminal(morf(I, by, qub))], J),
	formaczas(D, E, J, os, nd, K, war, L, M, C, N).

terminal(D, A, F, morf(G, by, qub)) :-
	goal(terminal(morf(I, B, pred)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(os, nd, K, war, L, M, C, N), D, E, n_cz33, [F/terminal(morf(G, by, qub)), A, H/terminal(morf(I, B, pred))], J),
	formaczas(D, E, J, os, nd, K, war, L, M, C, N).

terminal(D, A, F, morf(G, być, inf:imperf)) :-
	goal(terminal(morf(I, B, pred)), A, E, H),
	B\=to,
	rekcja_finitywna(B, C),
	register(formaczas(bok, nd, K, L, M, N, C, O), D, E, n_cz34, [F/terminal(morf(G, być, inf:imperf)), A, H/terminal(morf(I, B, pred))], J),
	formaczas(D, E, J, bok, nd, K, L, M, N, C, O).

terminal(G, C, I, morf(J, być, praet:A:B:imperf)) :-
	liczba(A, E),
	rodzaj(B, D),
	goal(terminal(morf(L, to, pred)), C, H, K),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, prze, ozn, D/E, 3, F, N), G, H, to2, [I/terminal(morf(J, być, praet:A:B:imperf)), C, K/terminal(morf(L, to, pred))], M),
	formaczas(G, H, M, os, nd, prze, ozn, D/E, 3, F, N).

terminal(J, C, L, morf(M, być, praet:A:B:imperf)) :-
	liczba(A, G),
	rodzaj(B, F),
	goal(terminal(morf(O, być, aglt:A:D:P:Q)), C, E, N),
	osoba(D, H),
	goal(terminal(morf(S, to, pred)), E, K, R),
	rekcja_finitywna(to, I),
	register(formaczas(os, nd, prze, ozn, F/G, H, I, U), J, K, to3, [L/terminal(morf(M, być, praet:A:B:imperf)), C, N/terminal(morf(O, być, aglt:A:D:P:Q)), E, R/terminal(morf(S, to, pred))], T),
	formaczas(J, K, T, os, nd, prze, ozn, F/G, H, I, U).

terminal(G, A, I, morf(J, to, pred)) :-
	goal(terminal(morf(L, być, praet:B:C:imperf)), A, H, K),
	liczba(B, E),
	rodzaj(C, D),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, prze, ozn, D/E, 3, F, N), G, H, to4, [I/terminal(morf(J, to, pred)), A, K/terminal(morf(L, być, praet:B:C:imperf))], M),
	formaczas(G, H, M, os, nd, prze, ozn, D/E, 3, F, N).

terminal(J, A, L, morf(M, to, pred)) :-
	goal(terminal(morf(O, być, praet:B:C:imperf)), A, D, N),
	liczba(B, G),
	rodzaj(C, F),
	goal(terminal(morf(Q, być, aglt:B:E:R:S)), D, K, P),
	osoba(E, H),
	rekcja_finitywna(to, I),
	register(formaczas(os, nd, prze, ozn, F/G, H, I, U), J, K, to5, [L/terminal(morf(M, to, pred)), A, N/terminal(morf(O, być, praet:B:C:imperf)), D, P/terminal(morf(Q, być, aglt:B:E:R:S))], T),
	formaczas(J, K, T, os, nd, prze, ozn, F/G, H, I, U).

terminal(G, C, I, morf(J, być, bedzie:B:A:imperf)) :-
	osoba(A, E),
	liczba(B, D),
	goal(terminal(morf(L, to, pred)), C, H, K),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, przy, ozn, N/D, E, F, O), G, H, to6, [I/terminal(morf(J, być, bedzie:B:A:imperf)), C, K/terminal(morf(L, to, pred))], M),
	formaczas(G, H, M, os, nd, przy, ozn, N/D, E, F, O).

terminal(G, A, I, morf(J, to, pred)) :-
	goal(terminal(morf(L, być, bedzie:C:B:imperf)), A, H, K),
	osoba(B, E),
	liczba(C, D),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, przy, ozn, N/D, E, F, O), G, H, to7, [I/terminal(morf(J, to, pred)), A, K/terminal(morf(L, być, bedzie:C:B:imperf))], M),
	formaczas(G, H, M, os, nd, przy, ozn, N/D, E, F, O).

terminal(G, C, I, morf(J, być, fin:B:A:imperf)) :-
	osoba(A, E),
	liczba(B, D),
	goal(terminal(morf(L, to, pred)), C, H, K),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, ter, ozn, N/D, E, F, O), G, H, to8, [I/terminal(morf(J, być, fin:B:A:imperf)), C, K/terminal(morf(L, to, pred))], M),
	formaczas(G, H, M, os, nd, ter, ozn, N/D, E, F, O).

terminal(G, A, I, morf(J, to, pred)) :-
	goal(terminal(morf(L, być, fin:C:B:imperf)), A, H, K),
	osoba(B, E),
	liczba(C, D),
	rekcja_finitywna(to, F),
	register(formaczas(os, nd, ter, ozn, N/D, E, F, O), G, H, to9, [I/terminal(morf(J, to, pred)), A, K/terminal(morf(L, być, fin:C:B:imperf))], M),
	formaczas(G, H, M, os, nd, ter, ozn, N/D, E, F, O).

terminal(J, K, L, morf(M, E, winien:C:D:A)) :-
	asagl(A, B, nagl),
	aspekt(B, F),
	liczba(C, H),
	rodzaj(D, G),
	rekcja_finitywna(E, I),
	register(formaczas(os, F, ter, ozn, G/H, 3, I, O), J, K, n_cz35, [L/terminal(morf(M, E, winien:C:D:A))], N),
	formaczas(J, K, N, os, F, ter, ozn, G/H, 3, I, O).

terminal(M, F, O, morf(P, E, winien:C:D:A)) :-
	asagl(A, B, agl),
	aspekt(B, H),
	liczba(C, J),
	rodzaj(D, I),
	rekcja_finitywna(E, L),
	goal(terminal(morf(R, być, aglt:C:G:S:T)), F, N, Q),
	osoba(G, K),
	register(formaczas(os, H, ter, ozn, I/J, K, L, V), M, N, n_cz36, [O/terminal(morf(P, E, winien:C:D:A)), F, Q/terminal(morf(R, być, aglt:C:G:S:T))], U),
	formaczas(M, N, U, os, H, ter, ozn, I/J, K, L, V).

terminal(E, F, G, morf(H, być, aglt:A:B:I:J)) :-
	liczba(A, D),
	osoba(B, C),
	register(posiłk(agl(C), L/D, agl, ni, (0 '|' 0), M), E, F, po1, [G/terminal(morf(H, być, aglt:A:B:I:J))], K),
	posiłk(E, F, K, agl(C), L/D, agl, ni, (0 '|' 0), M).

terminal(B, C, D, morf(E, A, qub)) :-
	member(A, [niech, niechaj, niechże, niechajże]),
	register(posiłk(niech, G, neut, ni, (0 '|' 0), H), B, C, po2, [D/terminal(morf(E, A, qub))], F),
	posiłk(B, C, F, niech, G, neut, ni, (0 '|' 0), H).

terminal(G, A, I, morf(J, być, praet:B:D:imperf)) :-
	goal(condaglt(C, E, na), A, H, K),
	liczba(B, C),
	rodzaj(D, F),
	register(posiłk(byłby(E, tak), F/C, neut, ni, (0 '|' 0), M), G, H, po4, [I/terminal(morf(J, być, praet:B:D:imperf)), A, K/condaglt(C, E, na)], L),
	posiłk(G, H, L, byłby(E, tak), F/C, neut, ni, (0 '|' 0), M).

terminal(E, F, G, morf(H, być, bedzie:B:A:imperf)) :-
	osoba(A, C),
	liczba(B, D),
	register(posiłk(bedzie(C, tak), J/D, neut, ni, (0 '|' 0), K), E, F, po5, [G/terminal(morf(H, być, bedzie:B:A:imperf))], I),
	posiłk(E, F, I, bedzie(C, tak), J/D, neut, ni, (0 '|' 0), K).

terminal(C, D, E, morf(F, G, adv:A)) :-
	stopien(A, B),
	register(formaprzys(B, przys, I, neut, J), C, D, eps1, [E/terminal(morf(F, G, adv:A))], H),
	formaprzys(C, D, H, B, przys, I, neut, J).

terminal(A, B, C, morf(D, E, adv)) :-
	register(formaprzys(row, przys, G, neut, H), A, B, eps2, [C/terminal(morf(D, E, adv))], F),
	formaprzys(A, B, F, row, przys, G, neut, H).

terminal(C, D, E, morf(F, A, padv)) :-
	równe(A, [dlaczego, dokąd, gdzie, jak, kiedy, którędy, odkąd, skąd, czemu]),
	równe(B, [pyt, pz]),
	register(formaprzys(row, przys, H, B, I), C, D, eps3, [E/terminal(morf(F, A, padv))], G),
	formaprzys(C, D, G, row, przys, H, B, I).

terminal(B, C, D, morf(E, A, padv)) :-
	równe(A, [dokąd, gdzie, jak, kiedy, którędy, odkąd, skąd]),
	register(formaprzys(row, przys, G, wz(A, przys), H), B, C, eps30, [D/terminal(morf(E, A, padv))], F),
	formaprzys(B, C, F, row, przys, G, wz(A, przys), H).

terminal(B, C, D, morf(E, A, padv)) :-
	member(A, [tak]),
	register(formaprzys(row, tk, G, neut, H), B, C, eps4, [D/terminal(morf(E, A, padv))], F),
	formaprzys(B, C, F, row, tk, G, neut, H).

terminal(A, B, C, morf(D, nigdy, padv)) :-
	register(formaprzys(row, przys, nie(F), neut, G), A, B, eps5, [C/terminal(morf(D, nigdy, padv))], E),
	formaprzys(A, B, E, row, przys, nie(F), neut, G).

terminal(C, B, E, morf(F, na, prep:A)) :-
	przypadki(A, bier),
	goal(terminal(morf(H, pewno, adv:pos)), B, D, G),
	register(formaprzys(row, przys, J, neut, K), C, D, eps10, [E/terminal(morf(F, na, prep:A)), B, G/terminal(morf(H, pewno, adv:pos))], I),
	formaprzys(C, D, I, row, przys, J, neut, K).

terminal(C, B, E, morf(F, na, prep:A)) :-
	przypadki(A, bier),
	goal(terminal(morf(H, zewnątrz, adv)), B, D, G),
	register(formaprzys(row, przys, J, neut, K), C, D, eps12, [E/terminal(morf(F, na, prep:A)), B, G/terminal(morf(H, zewnątrz, adv))], I),
	formaprzys(C, D, I, row, przys, J, neut, K).

terminal(B, A, D, morf(E, i, conj)) :-
	goal(terminal(morf(G, tak, padv)), A, C, F),
	register(formaprzys(row, przys, I, neut, J), B, C, eps11, [D/terminal(morf(E, i, conj)), A, F/terminal(morf(G, tak, padv))], H),
	formaprzys(B, C, H, row, przys, I, neut, J).

terminal(B, A, D, morf(E, jak, padv)) :-
	goal(terminal(morf(G, zwykle, adv:pos)), A, C, F),
	register(formaprzys(row, przys, I, neut, J), B, C, eps13, [D/terminal(morf(E, jak, padv)), A, F/terminal(morf(G, zwykle, adv:pos))], H),
	formaprzys(B, C, H, row, przys, I, neut, J).

terminal(B, C, D, morf(E, A, qub)) :-
	register(partykuła(A, G), B, C, jel2, [D/terminal(morf(E, A, qub))], F),
	partykuła(B, C, F, A, G).

terminal(D, E, F, morf(G, B, prep:A)) :-
	przypadki(A, C),
	register(przyimek(B, C, I), D, E, jel3, [F/terminal(morf(G, B, prep:A))], H),
	przyimek(D, E, H, B, C, I).

terminal(D, E, F, morf(G, B, prep:A:H)) :-
	przypadki(A, C),
	register(przyimek(B, C, J), D, E, jel3x, [F/terminal(morf(G, B, prep:A:H))], I),
	przyimek(D, E, I, B, C, J).

terminal(B, A, D, morf(co, co, prep:acc)) :-
	goal(terminal(morf(do, do, prep:gen)), A, C, E),
	register(przyimek('co do', dop, G), B, C, jel3a, [D/terminal(morf(co, co, prep:acc)), A, E/terminal(morf(do, do, prep:gen))], F),
	przyimek(B, C, F, 'co do', dop, G).

terminal(B, A, D, morf(na, na, prep:[acc|loc])) :-
	goal(terminal(morf(temat, temat, subst:sg:[nom|acc]:m3)), A, C, E),
	register(przyimek('na temat', dop, G), B, C, jel3b, [D/terminal(morf(na, na, prep:[acc|loc])), A, E/terminal(morf(temat, temat, subst:sg:[nom|acc]:m3))], F),
	przyimek(B, C, F, 'na temat', dop, G).

terminal(B, A, D, morf(w, w, prep:[acc|loc]:nwok)) :-
	goal(terminal(morf(sprawie, sprawa, subst:sg:[dat|loc]:f)), A, C, E),
	register(przyimek('w sprawie', dop, G), B, C, jel3c, [D/terminal(morf(w, w, prep:[acc|loc]:nwok)), A, E/terminal(morf(sprawie, sprawa, subst:sg:[dat|loc]:f))], F),
	przyimek(B, C, F, 'w sprawie', dop, G).

terminal(B, A, D, morf(z, z, prep:[gen, acc|inst]:nwok)) :-
	goal(terminal(morf(powodu, powód, subst:sg:gen:m3)), A, C, E),
	register(przyimek('z powodu', dop, G), B, C, jel3d, [D/terminal(morf(z, z, prep:[gen, acc|inst]:nwok)), A, E/terminal(morf(powodu, powód, subst:sg:gen:m3))], F),
	przyimek(B, C, F, 'z powodu', dop, G).

terminal(G, D, I, morf(J, A, brev:B)) :-
	slowskr(A, _, B, E, prep:C),
	przypadki(C, F),
	optional(K, [], D, H, terminal(morf('.', _, interp)), {E\=kon}, {E\=nkon}),
	register(przyimek(A, F, M), G, H, jel3, [I/terminal(morf(J, A, brev:B))|K], L),
	przyimek(G, H, L, A, F, M).

terminal(A, B, C, morf(?, D, interp)) :-
	register(znakkonca(pyt, F), A, B, int1, [C/terminal(morf(?, D, interp))], E),
	znakkonca(A, B, E, pyt, F).

terminal(B, A, D, morf(!, E, interp)) :-
	goal(terminal(morf(?, G, interp)), A, C, F),
	register(znakkonca(pyt, I), B, C, int8, [D/terminal(morf(!, E, interp)), A, F/terminal(morf(?, G, interp))], H),
	znakkonca(B, C, H, pyt, I).

terminal(B, A, D, morf(?, E, interp)) :-
	goal(terminal(morf(!, G, interp)), A, C, F),
	register(znakkonca(pyt, I), B, C, int9, [D/terminal(morf(?, E, interp)), A, F/terminal(morf(!, G, interp))], H),
	znakkonca(B, C, H, pyt, I).

terminal(D, A, F, morf('.', G, interp)) :-
	goal(terminal(morf('.', I, interp)), A, B, H),
	goal(terminal(morf('.', K, interp)), B, C, J),
	goal(terminal(morf(?, M, interp)), C, E, L),
	register(znakkonca(pyt, O), D, E, int11, [F/terminal(morf('.', G, interp)), A, H/terminal(morf('.', I, interp)), B, J/terminal(morf('.', K, interp)), C, L/terminal(morf(?, M, interp))], N),
	znakkonca(D, E, N, pyt, O).

terminal(D, A, F, morf(?, G, interp)) :-
	goal(terminal(morf('.', I, interp)), A, B, H),
	goal(terminal(morf('.', K, interp)), B, C, J),
	goal(terminal(morf('.', M, interp)), C, E, L),
	register(znakkonca(pyt, O), D, E, int12, [F/terminal(morf(?, G, interp)), A, H/terminal(morf('.', I, interp)), B, J/terminal(morf('.', K, interp)), C, L/terminal(morf('.', M, interp))], N),
	znakkonca(D, E, N, pyt, O).

terminal(A, B, C, morf('.', D, interp)) :-
	register(znakkonca(neut, F), A, B, int2, [C/terminal(morf('.', D, interp))], E),
	znakkonca(A, B, E, neut, F).

terminal(A, B, C, morf(!, D, interp)) :-
	register(znakkonca(neut, F), A, B, int3, [C/terminal(morf(!, D, interp))], E),
	znakkonca(A, B, E, neut, F).

terminal(C, A, E, morf(!, F, interp)) :-
	goal(terminal(morf(!, H, interp)), A, B, G),
	goal(terminal(morf(!, J, interp)), B, D, I),
	register(znakkonca(neut, L), C, D, int10, [E/terminal(morf(!, F, interp)), A, G/terminal(morf(!, H, interp)), B, I/terminal(morf(!, J, interp))], K),
	znakkonca(C, D, K, neut, L).

terminal(C, A, E, morf('.', F, interp)) :-
	goal(terminal(morf('.', H, interp)), A, B, G),
	goal(terminal(morf('.', J, interp)), B, D, I),
	register(znakkonca(neut, L), C, D, int4, [E/terminal(morf('.', F, interp)), A, G/terminal(morf('.', H, interp)), B, I/terminal(morf('.', J, interp))], K),
	znakkonca(C, D, K, neut, L).

terminal(A, B, C, morf('…', D, interp)) :-
	register(znakkonca(neut, F), A, B, int5, [C/terminal(morf('…', D, interp))], E),
	znakkonca(A, B, E, neut, F).

terminal(D, A, F, morf('.', G, interp)) :-
	goal(terminal(morf('.', I, interp)), A, B, H),
	goal(terminal(morf('.', K, interp)), B, C, J),
	goal(terminal(morf(!, M, interp)), C, E, L),
	register(znakkonca(neut, O), D, E, int7, [F/terminal(morf('.', G, interp)), A, H/terminal(morf('.', I, interp)), B, J/terminal(morf('.', K, interp)), C, L/terminal(morf(!, M, interp))], N),
	znakkonca(D, E, N, neut, O).

terminal(B, A, D, morf('…', E, interp)) :-
	goal(terminal(morf(!, G, interp)), A, C, F),
	register(znakkonca(neut, I), B, C, int5, [D/terminal(morf('…', E, interp)), A, F/terminal(morf(!, G, interp))], H),
	znakkonca(B, C, H, neut, I).

terminal(D, A, F, morf(!, G, interp)) :-
	goal(terminal(morf('.', I, interp)), A, B, H),
	goal(terminal(morf('.', K, interp)), B, C, J),
	goal(terminal(morf('.', M, interp)), C, E, L),
	register(znakkonca(neut, O), D, E, int8, [F/terminal(morf(!, G, interp)), A, H/terminal(morf('.', I, interp)), B, J/terminal(morf('.', K, interp)), C, L/terminal(morf('.', M, interp))], N),
	znakkonca(D, E, N, neut, O).

terminal(B, A, D, morf(!, E, interp)) :-
	goal(terminal(morf('…', G, interp)), A, C, F),
	register(znakkonca(neut, I), B, C, int9, [D/terminal(morf(!, E, interp)), A, F/terminal(morf('…', G, interp))], H),
	znakkonca(B, C, H, neut, I).

terminal(A, B, C, morf(D, ',', interp)) :-
	register(przec((+'|'+), F), A, B, int6, [C/terminal(morf(D, ',', interp))], E),
	przec(A, B, E, (+'|'+), F).

terminal(A, B, C, morf(D, ;, interp)) :-
	register(przec((+'|'+), F), A, B, int13, [C/terminal(morf(D, ;, interp))], E),
	przec(A, B, E, (+'|'+), F).

terminal(A, B, C, morf('"', D, interp)) :-
	register(cudz(F, G), A, B, intc1, [C/terminal(morf('"', D, interp))], E),
	cudz(A, B, E, F, G).

terminal(A, B, C, morf('„', D, interp)) :-
	register(cudz(o, F), A, B, intc2, [C/terminal(morf('„', D, interp))], E),
	cudz(A, B, E, o, F).

terminal(A, B, C, morf('”', D, interp)) :-
	register(cudz(z, F), A, B, intc3, [C/terminal(morf('”', D, interp))], E),
	cudz(A, B, E, z, F).

terminal(A, B, C, morf('“', D, interp)) :-
	register(cudz(F, G), A, B, intc2, [C/terminal(morf('“', D, interp))], E),
	cudz(A, B, E, F, G).

terminal(A, B, C, morf('—', D, interp)) :-
	register(pauza(F), A, B, intp1, [C/terminal(morf('—', D, interp))], E),
	pauza(A, B, E, F).

terminal(A, B, C, morf('–', D, interp)) :-
	register(pauza(F), A, B, intp2, [C/terminal(morf('–', D, interp))], E),
	pauza(A, B, E, F).

terminal(A, B, C, morf(-, D, interp)) :-
	register(pauza(F), A, B, intp3, [C/terminal(morf(-, D, interp))], E),
	pauza(A, B, E, F).

terminal(B, A, D, morf(-, E, interp)) :-
	goal(terminal(morf(-, G, interp)), A, C, F),
	register(pauza(I), B, C, intp4, [D/terminal(morf(-, E, interp)), A, F/terminal(morf(-, G, interp))], H),
	pauza(B, C, H, I).

terminal(C, A, E, morf(-, F, interp)) :-
	goal(terminal(morf(-, H, interp)), A, B, G),
	goal(terminal(morf(-, J, interp)), B, D, I),
	register(pauza(L), C, D, intp5, [E/terminal(morf(-, F, interp)), A, G/terminal(morf(-, H, interp)), B, I/terminal(morf(-, J, interp))], K),
	pauza(C, D, K, L).

terminal(A, B, C, morf('(', D, interp)) :-
	register(nawias(o, o, F), A, B, intn1, [C/terminal(morf('(', D, interp))], E),
	nawias(A, B, E, o, o, F).

terminal(A, B, C, morf(')', D, interp)) :-
	register(nawias(z, o, F), A, B, intn2, [C/terminal(morf(')', D, interp))], E),
	nawias(A, B, E, z, o, F).

terminal(A, B, C, morf('[', D, interp)) :-
	register(nawias(o, k, F), A, B, intn3, [C/terminal(morf('[', D, interp))], E),
	nawias(A, B, E, o, k, F).

terminal(A, B, C, morf(']', D, interp)) :-
	register(nawias(z, k, F), A, B, intn4, [C/terminal(morf(']', D, interp))], E),
	nawias(A, B, E, z, k, F).

fpt(F, G, H, A, I, J, wym([], K), L, M, B, C, D, E, na) :-
	member(A, [mian, narz]),
	register(fw(adjp(A), O, P, Q, R, S, B, C, D, E, T), F, G, wya1, [H/fpt(A, I, J, wym([], K), L, M, B, C, D, E, na)], N),
	fw(F, G, N, adjp(A), O, P, Q, R, S, B, C, D, E, T).

fpt(E, F, G, dop, H, I, wym([], J), K, L, nie(A), B, C, D, na) :-
	register(fw(adjp(bier), N, O, P, Q, R, nie(A), B, C, D, S), E, F, wya2, [G/fpt(dop, H, I, wym([], J), K, L, nie(A), B, C, D, na)], M),
	fw(E, F, M, adjp(bier), N, O, P, Q, R, nie(A), B, C, D, S).

fpt(D, E, F, bier, G, H, wym([], I), J, K, tak, A, B, C, na) :-
	register(fw(adjp(bier), M, N, O, P, Q, tak, A, B, C, R), D, E, wya3, [F/fpt(bier, G, H, wym([], I), J, K, tak, A, B, C, na)], L),
	fw(D, E, L, adjp(bier), M, N, O, P, Q, tak, A, B, C, R).

fpt(I, B, K, A, L, M, wym([], N), O, P, F, G, H, C, na) :-
	równe(A, [mian, dop, cel, bier, narz]),
	optional(Q, [], B, J, przec(D, po), {oblpk(E, [ (-'|'+), C, D])}, {E=C}),
	register(fl(S, T, U, V, F, G, H, E, W), I, J, lu15, [K/fpt(A, L, M, wym([], N), O, P, F, G, H, C, na)|Q], R),
	fl(I, J, R, S, T, U, V, F, G, H, E, W).

fpt(G, H, I, A, B/C, J, K, L, bzap, D, neut, E, F, na) :-
	register(fno(A, B/C, 3, wym(N, bw), przym, bzap, O, D, neut, E, F, P), G, H, no9, [I/fpt(A, B/C, J, K, L, bzap, D, neut, E, F, na)], M),
	fno(G, H, M, A, B/C, 3, wym(N, bw), przym, bzap, O, D, neut, E, F, P).

fpt(W2, D, Y2, G, A/B, Z2, wym([], A3), B3, Y, C, Z, A1, B1, po) :-
	sequence_of(C3, [E, K1/fno(C1, A/B, D1, E1, V, F1, G1, C, H1, I1, J1, na)|Q1], D, E, [[optional(przec(F, po), {}, {F= (-'|'+)}), fpt(G, A/B, J, wym([], L), K, M, C, N, O, I, po), optional(przec(H, po), {}, {H= (+'|'-)})]^[sprawdz_fpt_noa, F/I/H/P]^[J]^[K]^[L], fpm(Q, R, S, M, C, N, O, P, po)^[Q]^[R]^[S], fno(dop, T, 3, wym([], U), W, M, pre, C, N, O, P, po)^[T]^[U]^[sprawdz_kl_nod, V/W], fw(X, _, _, _, _, post, C, N, ni, P, po)^[zroblistę_iter, [], X, P1], modpart(fno, C, N, ni, P, po)]^[oblzap_iter, Y, M, L1]^[obldest_iter, Z, N, M1]^[oblink_iter, A1, O, N1]^[sprawdz_pk_iter, B1, P, O1]),
	goal(fno(C1, A/B, D1, E1, V, F1, G1, C, H1, I1, J1, na), E, R1, K1),
	E1=wym(_, [_|_]),
	sprawdz_kl_noa(V, C1, G),
	oblzap_iter(L1, F1, M2),
	obldest_iter(M1, H1, O2),
	oblink_iter(N1, I1, P2),
	sprawdz_pk_iter(O1, J1, Q2),
	wyjmijl(P1, E1, K2),
	sequence_of(Q1, [], R1, X2, [[optional(przec(S1, po), {}, {S1= (-'|'+)}), fpt(G, A/B, V1, wym([], X1), W1, Y1, C, Z1, A2, U1, po), optional(przec(T1, po), {}, {T1= (+'|'-)})]^[sprawdz_fpt_noa, S1/U1/T1/B2]^[V1]^[W1]^[X1], fpm(C2, D2, E2, Y1, C, Z1, A2, B2, po)^[C2]^[D2]^[E2], fno(dop, F2, 3, wym([], G2), H2, Y1, pre, C, Z1, A2, B2, po)^[F2]^[G2]^[sprawdz_kl_nod, V/H2], fzd(I2, nk, _, _, _, J2, ni, B2, po)^[sprawdz_fzd_noz, A/B/V/N2, I2, _]^[J2], fw(L2, _, _, _, _, post, C, Z1, ni, B2, po)^[oblwym_iter, K2, L2, R2], modpart(fno, C, Z1, ni, B2, po)]^[oblzap_iter, M2, Y1, N2]^[obldest_iter, O2, Z1, T2]^[oblink_iter, P2, A2, U2]^[sprawdz_pk_iter, Q2, B2, V2]),
	R2=wym([], S2),
	resztawym(S2),
	register(fno(C1, A/B, D1, wym(E3, bw), V, N2, G1, C, T2, U2, V2, F3), W2, X2, noa2, [Y2/fpt(G, A/B, Z2, wym([], A3), B3, Y, C, Z, A1, B1, po)|C3], D3),
	fno(W2, X2, D3, C1, A/B, D1, wym(E3, bw), V, N2, G1, C, T2, U2, V2, F3).

fpt(Q, C, S, dop, A/B, T, wym([], U), V, H, L, D, F, J, po) :-
	goal(flicz(mian, A/B, nuzg, I, E, G, K, na), C, R, W),
	obldest(M, D, E),
	oblink(N, F, G),
	oblzap(P, [H, I]),
	oblpk(O, [J, K]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, wym(Y, [[]]), Z, nuzg, A1, L, M, N, O, P), Q, R, nol10, [S/fpt(dop, A/B, T, wym([], U), V, H, L, D, F, J, po), C, W/flicz(mian, A/B, nuzg, I, E, G, K, na)], X),
	fno(Q, R, X, mian, r(mn(n), nmo(np(n)))/poj, 3, wym(Y, [[]]), Z, nuzg, A1, L, M, N, O, P).

fpt(Z, C, B1, dop, A/B, C1, wym([], D1), E1, O, M, F, I, R, po) :-
	goal(flicz(mian, A/B, nuzg, P, G, J, S, na), C, D, F1),
	goal(fno(dop, A/B, H1, U, E, Q, I1, N, H, L, T, po), D, A1, G1),
	różne(E, [uzg|nuzg]),
	obldest(X, [F, G, H]),
	oblink(K, I, J),
	oblink(K, J, L),
	oblneg(-ani, W, M, N),
	oblzap(V, [O, P, Q]),
	oblpk(Y, [R, S, T]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, U, nuzg, V, K1, W, X, K, Y, L1), Z, A1, nol11, [B1/fpt(dop, A/B, C1, wym([], D1), E1, O, M, F, I, R, po), C, F1/flicz(mian, A/B, nuzg, P, G, J, S, na), D, G1/fno(dop, A/B, H1, U, E, Q, I1, N, H, L, T, po)], J1),
	fno(Z, A1, J1, mian, r(mn(n), nmo(np(n)))/poj, 3, U, nuzg, V, K1, W, X, K, Y, L1).

fpt(Q, C, S, mian, A/B, T, wym([], U), V, H, M, D, F, J, po) :-
	goal(flicz(mian, A/B, nuzg, I, E, G, K, na), C, R, W),
	różne(_, [uzg|nuzg]),
	A=r(_, nmo(_)),
	obldest(N, [D, E]),
	oblink(O, F, G),
	oblzap(L, [H, I]),
	oblpk(P, [J, K]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, wym(Y, [[]]), nuzg, L, Z, M, N, O, P, A1), Q, R, nol12, [S/fpt(mian, A/B, T, wym([], U), V, H, M, D, F, J, po), C, W/flicz(mian, A/B, nuzg, I, E, G, K, na)], X),
	fno(Q, R, X, mian, r(mn(n), nmo(np(n)))/poj, 3, wym(Y, [[]]), nuzg, L, Z, M, N, O, P, A1).

fpt(Z, C, B1, mian, A/B, C1, wym([], D1), E1, O, M, F, I, R, po) :-
	goal(flicz(mian, A/B, nuzg, P, G, J, S, na), C, D, F1),
	goal(fno(dop, A/B, H1, U, E, Q, I1, N, H, L, T, po), D, A1, G1),
	różne(E, [uzg|nuzg]),
	A=r(_, nmo(_)),
	obldest(X, [F, G, H]),
	oblink(K, I, J),
	oblink(K, J, L),
	oblneg(-ani, W, M, N),
	oblzap(V, [O, P, Q]),
	oblpk(Y, [R, S, T]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, U, nuzg, V, K1, W, X, K, Y, L1), Z, A1, nol13, [B1/fpt(mian, A/B, C1, wym([], D1), E1, O, M, F, I, R, po), C, F1/flicz(mian, A/B, nuzg, P, G, J, S, na), D, G1/fno(dop, A/B, H1, U, E, Q, I1, N, H, L, T, po)], J1),
	fno(Z, A1, J1, mian, r(mn(n), nmo(np(n)))/poj, 3, U, nuzg, V, K1, W, X, K, Y, L1).

fpt(C1, B, E1, O, P, W, A, X, R, N, S, T, U, na) :-
	A=wym(_, [_|_]),
	sequence_of(F1, [], B, D1, [fps(C, D, E, F, G, H, po)^[C]^[D]^[E], fpm(I, J, K, Q, L, F, G, H, po)^[I]^[J]^[K]^[L], fw(M, _, _, _, _, post, tak, F, G, H, po)^[oblwym_iter, A, M, V], modpart(fpt, N, F, G, H, po), modjaki(O, P, Q, F, G, H, po)]^[oblzap_iter, R, Q, Y]^[obldest_iter, S, F, Z]^[oblink_iter, T, G, A1]^[sprawdz_pk_iter, U, H, B1]^[conajmniej1, 0, _, 1]),
	sprawdz_reszte(V),
	register(fpt(O, P, W, wym(H1, bw), X, Y, N, Z, A1, B1, I1), C1, D1, pts1, [E1/fpt(O, P, W, A, X, R, N, S, T, U, na)|F1], G1),
	fpt(C1, D1, G1, O, P, W, wym(H1, bw), X, Y, N, Z, A1, B1, I1).

fpt(B1, F, D1, A, B/C, E1, wym([], F1), G1, D, E, J, Z, V, po) :-
	sequence_of(H1, [G, O/spójnik(szk, M, ni, na), N, U/fpt(A, B/C, Q, wym([], R), S, D, E, T, ni, I, po)], F, G, [[spójnik(sz, przec, ni, po), fpt(A, B/C, _, wym([], L), _, D, E, K, ni, H, po)]^[dwa_na_listę, W, [ (+'|'wp), H], [P, I]]^[obldest_fno_iter, J, K, X]^[L]]),
	goal(spójnik(szk, M, ni, na), G, N, O),
	(   M=przec
	->  P= (+'|'wp)
	;   P= (0 '|' 0)
	),
	sprawdz_neg(M, E),
	goal(fpt(A, B/C, Q, wym([], R), S, D, E, T, ni, I, po), N, C1, U),
	oblpk(A1, [V|W]),
	obldest_fno_iter(X, T, Y),
	register(fpt(A, B/C, J1, wym([], [[]]), K1, D, E, Y, Z, A1, L1), B1, C1, ptsz3, [D1/fpt(A, B/C, E1, wym([], F1), G1, D, E, J, Z, V, po)|H1], I1),
	fpt(B1, C1, I1, A, B/C, J1, wym([], [[]]), K1, D, E, Y, Z, A1, L1).

fps(E, F, G, H, I, A, B, C, D, na) :-
	register(fw(advp, K, L, M, N, O, A, B, C, D, P), E, F, wy9, [G/fps(H, I, A, B, C, D, na)], J),
	fw(E, F, J, advp, K, L, M, N, O, A, B, C, D, P).

fps(H, A, J, K, L, E, F, G, B, na) :-
	optional(M, [], A, I, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	register(fl(O, P, Q, R, E, F, G, D, S), H, I, lu3, [J/fps(K, L, E, F, G, B, na)|M], N),
	fl(H, I, N, O, P, Q, R, E, F, G, D, S).

fps(I1, B, K1, L1, M1, A, G, I, J, po) :-
	sequence_of(N1, [C, S/fpm(L, M, N, O, A, P, Q, R, na)|W], B, C, [fps(D, E, A, Y, F, Z, po)^[D]^[E], modpart(fpm, A, H, F, K, po)]^[obldest_iter, G, H, T]^[oblink_iter, I, F, U]^[sprawdz_pk_iter, J, K, V]),
	goal(fpm(L, M, N, O, A, P, Q, R, na), C, X, S),
	N\=mod,
	obldest_iter(T, P, D1),
	oblink_iter(U, Q, _),
	sprawdz_pk_iter(V, R, E1),
	sequence_of(W, [], X, J1, [fps(A1, B1, A, Y, C1, Z, po)^[A1]^[B1], modpart(fpm, A, Y, C1, Z, po)]^[obldest_iter, D1, Y, F1]^[oblink_iter, U, C1, G1]^[sprawdz_pk_iter, E1, Z, H1]),
	register(fpm(L, M, mod, O, A, F1, G1, H1, P1), I1, J1, pm5, [K1/fps(L1, M1, A, G, I, J, po)|N1], O1),
	fpm(I1, J1, O1, L, M, mod, O, A, F1, G1, H1, P1).

fps(F2, A, H2, I2, J2, K2, R, S, T, po) :-
	sequence_of(L2, [B, B1/fpt(O, P, U, V, W, X, N, Y, Z, A1, na)|H1], A, B, [fps(C, D, E, F, G, H, po)^[C]^[D]^[E], fpm(I, J, K, Q, L, F, G, H, po)^[I]^[J]^[K]^[L], fw(M, _, _, _, _, post, tak, F, G, H, po)^[zroblistę_iter, [], M, G1], modpart(fpt, N, F, G, H, po), modjaki(O, P, Q, F, G, H, po)]^[oblzap_iter, _, Q, C1]^[obldest_iter, R, F, D1]^[oblink_iter, S, G, E1]^[sprawdz_pk_iter, T, H, F1]),
	goal(fpt(O, P, U, V, W, X, N, Y, Z, A1, na), B, I1, B1),
	V=wym(_, [_|_]),
	oblzap_iter(C1, X, W1),
	obldest_iter(D1, Y, X1),
	oblink_iter(E1, Z, Y1),
	sprawdz_pk_iter(F1, A1, Z1),
	wyjmijl(G1, V, T1),
	sequence_of(H1, [], I1, G2, [fps(J1, K1, L1, M1, N1, O1, po)^[J1]^[K1]^[L1], fpm(P1, Q1, R1, V1, S1, M1, N1, O1, po)^[P1]^[Q1]^[R1]^[S1], fw(U1, _, _, _, _, post, tak, M1, N1, O1, po)^[oblwym_iter, T1, U1, A2], modpart(fpt, N, M1, N1, O1, po), modjaki(O, P, V1, M1, N1, O1, po)]^[oblzap_iter, W1, V1, B2]^[obldest_iter, X1, M1, C2]^[oblink_iter, Y1, N1, D2]^[sprawdz_pk_iter, Z1, O1, E2]),
	sprawdz_reszte(A2),
	register(fpt(O, P, U, wym(N2, bw), W, B2, N, C2, D2, E2, O2), F2, G2, pts2, [H2/fps(I2, J2, K2, R, S, T, po)|L2], M2),
	fpt(F2, G2, M2, O, P, U, wym(N2, bw), W, B2, N, C2, D2, E2, O2).

fps(S, B, U, O, A, C, L, M, N, na) :-
	A\=mod,
	sequence_of(V, [], B, T, [fpm(D, E, F, G, C, H, I, J, po)^[D]^[E]^[F]^[G], fps(K, F, C, H, I, J, po)^[K]^[F], modpart(fpt, C, H, I, J, po)]^[obldest_iter, L, H, P]^[oblink_iter, M, I, Q]^[sprawdz_pk_iter, N, J, R]^[conajmniej1, 0, _, 1]),
	register(fps(O, mod, C, P, Q, R, X), S, T, psm1, [U/fps(O, A, C, L, M, N, na)|V], W),
	fps(S, T, W, O, mod, C, P, Q, R, X).

fps(N1, B, P1, Q1, R1, A, L, M, N, po) :-
	sequence_of(S1, [C, T/fps(O, P, A, Q, R, S, na)|X], B, C, [fpm(D, E, F, G, A, H, I, J, po)^[D]^[E]^[F]^[G], fps(K, F, A, H, I, J, po)^[K]^[F], modpart(fpt, A, H, I, J, po)]^[obldest_iter, L, H, U]^[oblink_iter, M, I, V]^[sprawdz_pk_iter, N, J, W]),
	goal(fps(O, P, A, Q, R, S, na), C, Y, T),
	P\=mod,
	obldest_iter(U, Q, H1),
	oblink_iter(V, R, I1),
	sprawdz_pk_iter(W, S, J1),
	sequence_of(X, [], Y, O1, [fpm(Z, A1, B1, C1, A, D1, E1, F1, po)^[Z]^[A1]^[B1]^[C1], fps(G1, B1, A, D1, E1, F1, po)^[G1]^[B1], modpart(fpt, A, D1, E1, F1, po)]^[obldest_iter, H1, D1, K1]^[oblink_iter, I1, E1, L1]^[sprawdz_pk_iter, J1, F1, M1]),
	register(fps(O, mod, A, K1, L1, M1, U1), N1, O1, psm2, [P1/fps(Q1, R1, A, L, M, N, po)|S1], T1),
	fps(N1, O1, T1, O, mod, A, K1, L1, M1, U1).

przec(J, A, L, C, po) :-
	goal(fpm(N, O, P, Q, G, H, I, D, na), A, B, M),
	optional(R, [], B, K, przec(E, po), {oblpk(F, [C, D, E])}, {oblpk(F, [C, D, (+'|'-)])}),
	register(fl(T, U, V, W, G, H, I, F, X), J, K, lu1p, [L/przec(C, po), A, M/fpm(N, O, P, Q, G, H, I, D, na)|R], S),
	fl(J, K, S, T, U, V, W, G, H, I, F, X).

przec(L, A, N, E, po) :-
	goal(fno(B, P, Q, wym([], R), C, S, pre, I, J, K, F, na), A, D, O),
	równe(B, [cel, bier, narz]),
	C\=przym,
	optional(T, [], D, M, przec(G, po), {oblpk(H, [E, F, G])}, {oblpk(H, [E, F, (+'|'-)])}),
	register(fl(V, W, X, Y, I, J, K, H, Z), L, M, lu2p, [N/przec(E, po), A, O/fno(B, P, Q, wym([], R), C, S, pre, I, J, K, F, na)|T], U),
	fl(L, M, U, V, W, X, Y, I, J, K, H, Z).

przec(J, A, L, C, po) :-
	goal(fps(N, O, G, H, I, D, na), A, B, M),
	optional(P, [], B, K, przec(E, po), {oblpk(F, [C, D, E])}, {oblpk(F, [C, D, (+'|'-)])}),
	register(fl(R, S, T, U, G, H, I, F, V), J, K, lu3p, [L/przec(C, po), A, M/fps(N, O, G, H, I, D, na)|P], Q),
	fl(J, K, Q, R, S, T, U, G, H, I, F, V).

przec(I, A, K, C, po) :-
	goal(modpart(fin, G, H, ni, D, na), A, B, L),
	optional(M, [], B, J, przec(E, po), {oblpk(F, [C, D, E])}, {oblpk(F, [C, D, (+'|'-)])}),
	register(fl(O, P, Q, R, G, H, ni, F, S), I, J, lu4p, [K/przec(C, po), A, L/modpart(fin, G, H, ni, D, na)|M], N),
	fl(I, J, N, O, P, Q, R, G, H, ni, F, S).

przec(I, A, K, E, po) :-
	goal(fno(wol, G, M, wym([], N), B, O, pre, P, neut, ni, F, na), A, C, L),
	B\=przym,
	optional(Q, [], C, J, przec(D, po), {}, {D= (+'|'-)}),
	oblpk(H, [E, F, D]),
	register(fl(S, T, G, 2, U, neut, ni, H, V), I, J, lu12, [K/przec(E, po), A, L/fno(wol, G, M, wym([], N), B, O, pre, P, neut, ni, F, na)|Q], R),
	fl(I, J, R, S, T, G, 2, U, neut, ni, H, V).

przec(I, A, K, E, po) :-
	goal(fno(wol, M, N, wym([], O), B, P, pre, Q, neut, ni, F, na), A, C, L),
	B\=przym,
	optional(R, [], C, J, przec(D, po), {}, {D= (+'|'-)}),
	równe(G, [1, 3]),
	oblpk(H, [E, F, D]),
	register(fl(T, U, V, G, W, neut, ni, H, X), I, J, lu13, [K/przec(E, po), A, L/fno(wol, M, N, wym([], O), B, P, pre, Q, neut, ni, F, na)|R], S),
	fl(I, J, S, T, U, V, G, W, neut, ni, H, X).

przec(K, A, M, D, po) :-
	goal(fpt(B, O, P, wym([], Q), R, S, H, I, J, E, na), A, C, N),
	równe(B, [mian, dop, cel, bier, narz]),
	optional(T, [], C, L, przec(F, po), {oblpk(G, [D, E, F])}, {oblpk(G, [D, E, (+'|'-)])}),
	register(fl(V, W, X, Y, H, I, J, G, Z), K, L, lu15p, [M/przec(D, po), A, N/fpt(B, O, P, wym([], Q), R, S, H, I, J, E, na)|T], U),
	fl(K, L, U, V, W, X, Y, H, I, J, G, Z).

przec(I, A, K, D, po) :-
	goal(fwe(psw, M, F, N, O, P, wym([], Q), R, neut, G, E, na), A, B, L),
	optional(S, [], B, J, przec(C, po), {}, {C= (+'|'-)}),
	oblpk(H, [D, E, C]),
	register(fl(U, F, V, W, X, neut, G, H, Y), I, J, luw1, [K/przec(D, po), A, L/fwe(psw, M, F, N, O, P, wym([], Q), R, neut, G, E, na)|S], T),
	fl(I, J, T, U, F, V, W, X, neut, G, H, Y).

przec(H, A, J, D, po) :-
	goal(fwe(psu, L, prze, M, N, O, wym([], P), Q, neut, F, E, na), A, B, K),
	optional(R, [], B, I, przec(C, po), {}, {C= (+'|'-)}),
	oblpk(G, [D, E, C]),
	register(fl(T, U, V, W, X, neut, F, G, Y), H, I, luw2, [J/przec(D, po), A, K/fwe(psu, L, prze, M, N, O, wym([], P), Q, neut, F, E, na)|R], S),
	fl(H, I, S, T, U, V, W, X, neut, F, G, Y).

przec(I, A, K, E, po) :-
	goal(fwe(psu, M, D, N, O, P, wym([], Q), R, neut, G, F, na), A, B, L),
	optional(S, [], B, J, przec(C, po), {}, {C= (+'|'-)}),
	D\=prze,
	oblpk(H, [E, F, C]),
	register(fl(U, przy, V, W, X, neut, G, H, Y), I, J, luw3, [K/przec(E, po), A, L/fwe(psu, M, D, N, O, P, wym([], Q), R, neut, G, F, na)|S], T),
	fl(I, J, T, U, przy, V, W, X, neut, G, H, Y).

przec(M, A, O, E, po) :-
	goal(zdanie(Q, G, H, I, R, S, J, D, K, F, na), A, B, P),
	optional(T, [], B, N, przec(C, po), {}, {C= (+'|'-)}),
	równe(D, [wz(_, _), pz]),
	oblpk(L, [E, F, C]),
	register(fzd(D, nk, G, H, I, J, K, L, V), M, N, zd1, [O/przec(E, po), A, P/zdanie(Q, G, H, I, R, S, J, D, K, F, na)|T], U),
	fzd(M, N, U, D, nk, G, H, I, J, K, L, V).

przec(N, A, P, F, po) :-
	goal(spójnik(po, E, L, na), A, B, Q),
	goal(zdanie(S, H, I, J, T, U, K, neut, ni, G, po), B, C, R),
	optional(V, [], C, O, przec(D, po), {}, {D= (+'|'-)}),
	member(E, [aż, chociaż, czy, dopóki, gdy, jak, jeśli, podczas, ponieważ, zanim, że]),
	oblpk(M, [F, G, D]),
	register(fzd(E, nk, H, I, J, K, L, M, X), N, O, zds1, [P/przec(F, po), A, Q/spójnik(po, E, L, na), B, R/zdanie(S, H, I, J, T, U, K, neut, ni, G, po)|V], W),
	fzd(N, O, W, E, nk, H, I, J, K, L, M, X).

przec(P, A, R, H, po) :-
	goal(spójnik(po, G, N, na), A, B, S),
	goal(zdanie(U, J, K, L, V, C, M, D, ni, I, po), B, E, T),
	member(C/D, [3/neut, _/agl]),
	optional(W, [], E, Q, przec(F, po), {}, {F= (+'|'-)}),
	member(G, [choćby, gdyby, jakby, jakoby, żeby]),
	oblpk(O, [H, I, F]),
	register(fzd(G, nk, J, K, L, M, N, O, Y), P, Q, zds2, [R/przec(H, po), A, S/spójnik(po, G, N, na), B, T/zdanie(U, J, K, L, V, C, M, D, ni, I, po)|W], X),
	fzd(P, Q, X, G, nk, J, K, L, M, N, O, Y).

modpart(H, A, J, fin, E, F, G, B, na) :-
	optional(K, [], A, I, przec(C, po), {oblpk(D, [ (-'|'+), B, C])}, {D=B}),
	register(fl(M, N, O, P, E, F, G, D, Q), H, I, lu4, [J/modpart(fin, E, F, G, B, na)|K], L),
	fl(H, I, L, M, N, O, P, E, F, G, D, Q).

modpart(V2, B, X2, fno, A, X, Y, Z, po) :-
	sequence_of(Y2, [C, I1/fno(A1, E/F, B1, C1, U, D1, E1, A, F1, G1, H1, na)|P1], B, C, [[optional(przec(D, po), {}, {D= (-'|'+)}), fpt(J1, E/F, I, wym([], K), J, L, A, M, N, H, po), optional(przec(G, po), {}, {G= (+'|'-)})]^[sprawdz_fpt_noa, D/H/G/O]^[I]^[J]^[K], fpm(P, Q, R, L, A, M, N, O, po)^[P]^[Q]^[R], fno(dop, S, 3, wym([], T), V, L, pre, A, M, N, O, po)^[S]^[T]^[sprawdz_kl_nod, U/V], fw(W, _, _, _, _, post, A, M, ni, O, po)^[zroblistę_iter, [], W, O1], modpart(fno, A, M, ni, O, po)]^[oblzap_iter, bzap, L, K1]^[obldest_iter, X, M, L1]^[oblink_iter, Y, N, M1]^[sprawdz_pk_iter, Z, O, N1]),
	goal(fno(A1, E/F, B1, C1, U, D1, E1, A, F1, G1, H1, na), C, Q1, I1),
	C1=wym(_, [_|_]),
	sprawdz_kl_noa(U, A1, J1),
	oblzap_iter(K1, D1, L2),
	obldest_iter(L1, F1, N2),
	oblink_iter(M1, G1, O2),
	sprawdz_pk_iter(N1, H1, P2),
	wyjmijl(O1, C1, J2),
	sequence_of(P1, [], Q1, W2, [[optional(przec(R1, po), {}, {R1= (-'|'+)}), fpt(J1, E/F, U1, wym([], W1), V1, X1, A, Y1, Z1, T1, po), optional(przec(S1, po), {}, {S1= (+'|'-)})]^[sprawdz_fpt_noa, R1/T1/S1/A2]^[U1]^[V1]^[W1], fpm(B2, C2, D2, X1, A, Y1, Z1, A2, po)^[B2]^[C2]^[D2], fno(dop, E2, 3, wym([], F2), G2, X1, pre, A, Y1, Z1, A2, po)^[E2]^[F2]^[sprawdz_kl_nod, U/G2], fzd(H2, nk, _, _, _, I2, ni, A2, po)^[sprawdz_fzd_noz, E/F/U/M2, H2, _]^[I2], fw(K2, _, _, _, _, post, A, Y1, ni, A2, po)^[oblwym_iter, J2, K2, Q2], modpart(fno, A, Y1, ni, A2, po)]^[oblzap_iter, L2, X1, M2]^[obldest_iter, N2, Y1, S2]^[oblink_iter, O2, Z1, T2]^[sprawdz_pk_iter, P2, A2, U2]),
	Q2=wym([], R2),
	resztawym(R2),
	register(fno(A1, E/F, B1, wym(A3, bw), U, M2, E1, A, S2, T2, U2, B3), V2, W2, nom1, [X2/modpart(fno, A, X, Y, Z, po)|Y2], Z2),
	fno(V2, W2, Z2, A1, E/F, B1, wym(A3, bw), U, M2, E1, A, S2, T2, U2, B3).

modpart(I1, B, K1, fpm, A, G, I, J, po) :-
	sequence_of(L1, [C, S/fpm(L, M, N, O, A, P, Q, R, na)|W], B, C, [fps(D, E, A, Y, F, Z, po)^[D]^[E], modpart(fpm, A, H, F, K, po)]^[obldest_iter, G, H, T]^[oblink_iter, I, F, U]^[sprawdz_pk_iter, J, K, V]),
	goal(fpm(L, M, N, O, A, P, Q, R, na), C, X, S),
	N\=mod,
	obldest_iter(T, P, D1),
	oblink_iter(U, Q, _),
	sprawdz_pk_iter(V, R, E1),
	sequence_of(W, [], X, J1, [fps(A1, B1, A, Y, C1, Z, po)^[A1]^[B1], modpart(fpm, A, Y, C1, Z, po)]^[obldest_iter, D1, Y, F1]^[oblink_iter, U, C1, G1]^[sprawdz_pk_iter, E1, Z, H1]),
	register(fpm(L, M, mod, O, A, F1, G1, H1, N1), I1, J1, pm3, [K1/modpart(fpm, A, G, I, J, po)|L1], M1),
	fpm(I1, J1, M1, L, M, mod, O, A, F1, G1, H1, N1).

modpart(F2, B, H2, fpt, A, R, S, T, po) :-
	sequence_of(I2, [C, B1/fpt(O, P, U, V, W, X, A, Y, Z, A1, na)|H1], B, C, [fps(D, E, F, G, H, I, po)^[D]^[E]^[F], fpm(J, K, L, Q, M, G, H, I, po)^[J]^[K]^[L]^[M], fw(N, _, _, _, _, post, tak, G, H, I, po)^[zroblistę_iter, [], N, G1], modpart(fpt, A, G, H, I, po), modjaki(O, P, Q, G, H, I, po)]^[oblzap_iter, _, Q, C1]^[obldest_iter, R, G, D1]^[oblink_iter, S, H, E1]^[sprawdz_pk_iter, T, I, F1]),
	goal(fpt(O, P, U, V, W, X, A, Y, Z, A1, na), C, I1, B1),
	V=wym(_, [_|_]),
	oblzap_iter(C1, X, W1),
	obldest_iter(D1, Y, X1),
	oblink_iter(E1, Z, Y1),
	sprawdz_pk_iter(F1, A1, Z1),
	wyjmijl(G1, V, T1),
	sequence_of(H1, [], I1, G2, [fps(J1, K1, L1, M1, N1, O1, po)^[J1]^[K1]^[L1], fpm(P1, Q1, R1, V1, S1, M1, N1, O1, po)^[P1]^[Q1]^[R1]^[S1], fw(U1, _, _, _, _, post, tak, M1, N1, O1, po)^[oblwym_iter, T1, U1, A2], modpart(fpt, A, M1, N1, O1, po), modjaki(O, P, V1, M1, N1, O1, po)]^[oblzap_iter, W1, V1, B2]^[obldest_iter, X1, M1, C2]^[oblink_iter, Y1, N1, D2]^[sprawdz_pk_iter, Z1, O1, E2]),
	sprawdz_reszte(A2),
	register(fpt(O, P, U, wym(K2, bw), W, B2, A, C2, D2, E2, L2), F2, G2, ptm3, [H2/modpart(fpt, A, R, S, T, po)|I2], J2),
	fpt(F2, G2, J2, O, P, U, wym(K2, bw), W, B2, A, C2, D2, E2, L2).

modpart(A1, A, C1, flicz, C, D, Y, F, po) :-
	sequence_of(D1, [B, O/flicz(H, I, J, K, L, ni, M, N)|R], A, B, [modpart(flicz, C, E, ni, G, po)]^[obldest_iter, D, E, P]^[sprawdz_pk_iter, F, G, Q]),
	goal(flicz(H, I, J, K, L, ni, M, N), B, S, O),
	var(N),
	N=na,
	obldest_iter(P, L, T),
	sprawdz_pk_iter(Q, M, V),
	sequence_of(R, [], S, B1, [modpart(flicz, C, U, ni, W, po)]^[obldest_iter, T, U, X]^[sprawdz_pk_iter, V, W, Z]),
	register(flicz(H, I, J, K, X, Y, Z, na), A1, B1, lim1, [C1/modpart(flicz, C, D, Y, F, po)|D1], E1),
	flicz(A1, B1, E1, H, I, J, K, X, Y, Z, na).

modpart(N1, B, P1, fpt, A, L, M, N, po) :-
	sequence_of(Q1, [C, T/fps(O, P, A, Q, R, S, na)|X], B, C, [fpm(D, E, F, G, A, H, I, J, po)^[D]^[E]^[F]^[G], fps(K, F, A, H, I, J, po)^[K]^[F], modpart(fpt, A, H, I, J, po)]^[obldest_iter, L, H, U]^[oblink_iter, M, I, V]^[sprawdz_pk_iter, N, J, W]),
	goal(fps(O, P, A, Q, R, S, na), C, Y, T),
	P\=mod,
	obldest_iter(U, Q, H1),
	oblink_iter(V, R, I1),
	sprawdz_pk_iter(W, S, J1),
	sequence_of(X, [], Y, O1, [fpm(Z, A1, B1, C1, A, D1, E1, F1, po)^[Z]^[A1]^[B1]^[C1], fps(G1, B1, A, D1, E1, F1, po)^[G1]^[B1], modpart(fpt, A, D1, E1, F1, po)]^[obldest_iter, H1, D1, K1]^[oblink_iter, I1, E1, L1]^[sprawdz_pk_iter, J1, F1, M1]),
	register(fps(O, mod, A, K1, L1, M1, S1), N1, O1, psm3, [P1/modpart(fpt, A, L, M, N, po)|Q1], R1),
	fps(N1, O1, R1, O, mod, A, K1, L1, M1, S1).

modpart(H, A, J, B, C, D, ni, G, na) :-
	goal(spójnik(i(E, F), L, ni, po), A, I, K),
	register(modpart(B, C, D, i(E, F), G, N), H, I, mp4, [J/modpart(B, C, D, ni, G, na), A, K/spójnik(i(E, F), L, ni, po)], M),
	modpart(H, I, M, B, C, D, i(E, F), G, N).

formaczas(L, A, N, E, F, G, H, I, J, K, na) :-
	optional(O, [], A, M, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fwe(E, F, G, H, I, J, K, tak, neut, D, (0 '|' 0), Q), L, M, we1, [N/formaczas(E, F, G, H, I, J, K, na)|O], P),
	fwe(L, M, P, E, F, G, H, I, J, K, tak, neut, D, (0 '|' 0), Q).

partykuła(M, A, O, nie, po) :-
	goal(formaczas(F, G, H, I, J, K, L, na), A, B, P),
	optional(Q, [], B, N, spójnik(i(C, D), _, ni, po), {E=i(C, D)}, {E=ni}),
	register(fwe(F, G, H, I, J, K, L, nie(S), neut, E, (0 '|' 0), T), M, N, we2, [O/partykuła(nie, po), A, P/formaczas(F, G, H, I, J, K, L, na)|Q], R),
	fwe(M, N, R, F, G, H, I, J, K, L, nie(S), neut, E, (0 '|' 0), T).

partykuła(G, A, I, nie, po) :-
	goal(posiłk(bedzie(B, tak), C, D, E, F, na), A, H, J),
	register(posiłk(bedzie(B, nie(L)), C, D, E, F, M), G, H, po6, [I/partykuła(nie, po), A, J/posiłk(bedzie(B, tak), C, D, E, F, na)], K),
	posiłk(G, H, K, bedzie(B, nie(L)), C, D, E, F, M).

formarzecz(I, A, K, E, F/G, H, na) :-
	optional(L, [], A, J, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, 3, H, rzecz, bzap, N, O, neut, D, (0 '|' 0), P), I, J, no1, [K/formarzecz(E, F/G, H, na)|L], M),
	fno(I, J, M, E, F/G, 3, H, rzecz, bzap, N, O, neut, D, (0 '|' 0), P).

zaimos(I, A, K, E, F/G, H, na) :-
	optional(L, [], A, J, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, H, wym(N, [[]]), os, bzap, O, P, neut, D, (0 '|' 0), Q), I, J, no2, [K/zaimos(E, F/G, H, na)|L], M),
	fno(I, J, M, E, F/G, H, wym(N, [[]]), os, bzap, O, P, neut, D, (0 '|' 0), Q).

zaimrzecz(I, B, K, A, F, G/H, na) :-
	równe(A, [ktoś|ktokolwiek]),
	optional(L, [], B, J, spójnik(i(C, D), _, ni, po), {E=i(C, D)}, {E=ni}),
	register(fno(F, G/H, 3, wym(N, [[]]), kto, bzap, O, P, neut, E, (0 '|' 0), Q), I, J, no3, [K/zaimrzecz(A, F, G/H, na)|L], M),
	fno(I, J, M, F, G/H, 3, wym(N, [[]]), kto, bzap, O, P, neut, E, (0 '|' 0), Q).

zaimrzecz(I, B, K, A, F, G/H, na) :-
	równe(A, [coś|cokolwiek]),
	optional(L, [], B, J, spójnik(i(C, D), _, ni, po), {E=i(C, D)}, {E=ni}),
	register(fno(F, G/H, 3, wym(N, [[]]), co, bzap, O, P, neut, E, (0 '|' 0), Q), I, J, no4, [K/zaimrzecz(A, F, G/H, na)|L], M),
	fno(I, J, M, F, G/H, 3, wym(N, [[]]), co, bzap, O, P, neut, E, (0 '|' 0), Q).

zaimrzecz(H, A, J, nic, E, F/G, na) :-
	optional(K, [], A, I, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, 3, wym(M, [[]]), co, bzap, N, nie(O), neut, D, (0 '|' 0), P), H, I, no5, [J/zaimrzecz(nic, E, F/G, na)|K], L),
	fno(H, I, L, E, F/G, 3, wym(M, [[]]), co, bzap, N, nie(O), neut, D, (0 '|' 0), P).

zaimrzecz(H, A, J, nikt, E, F/G, na) :-
	optional(K, [], A, I, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, 3, wym(M, [[]]), kto, bzap, N, nie(O), neut, D, (0 '|' 0), P), H, I, no6, [J/zaimrzecz(nikt, E, F/G, na)|K], L),
	fno(H, I, L, E, F/G, 3, wym(M, [[]]), kto, bzap, N, nie(O), neut, D, (0 '|' 0), P).

zaimrzecz(H, A, J, to, E, F/G, na) :-
	optional(K, [], A, I, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, 3, wym(M, [[]]), rzecz, bzap, N, O, neut, D, (0 '|' 0), P), H, I, no7, [J/zaimrzecz(to, E, F/G, na)|K], L),
	fno(H, I, L, E, F/G, 3, wym(M, [[]]), rzecz, bzap, N, O, neut, D, (0 '|' 0), P).

zaimrzecz(J, D, L, A, H, B/C, na) :-
	równe(A, [co|kto]),
	równe(I, [pyt, pz|wz(A, B/C)]),
	optional(M, [], D, K, spójnik(i(E, F), _, ni, po), {G=i(E, F)}, {G=ni}),
	register(fno(H, B/C, 3, wym(O, [[]]), A, bzap, P, Q, I, G, (0 '|' 0), R), J, K, no8, [L/zaimrzecz(A, H, B/C, na)|M], N),
	fno(J, K, N, H, B/C, 3, wym(O, [[]]), A, bzap, P, Q, I, G, (0 '|' 0), R).

zaimrzecz(B, C, D, to, A, E/poj, na) :-
	\+ member(A, [mian, miej, wol]),
	register(korelat(A, ni, G), B, C, kor2, [D/zaimrzecz(to, A, E/poj, na)], F),
	korelat(B, C, F, A, ni, G).

zaimprzym(H, A, J, który, E, F/G, na) :-
	optional(K, [], A, I, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fno(E, F/G, 3, wym(M, [[]]), który, bzap, N, O, wz(który, F/G), D, (0 '|' 0), P), H, I, no7, [J/zaimprzym(który, E, F/G, na)|K], L),
	fno(H, I, L, E, F/G, 3, wym(M, [[]]), który, bzap, N, O, wz(który, F/G), D, (0 '|' 0), P).

zaimprzym(I, C, K, A, G, B, na) :-
	równe(A, [czyj, jaki, który]),
	równe(H, [pyt, pz|wz(A, B)]),
	optional(L, [], C, J, spójnik(i(D, E), _, ni, po), {F=i(D, E)}, {F=ni}),
	register(fpt(G, B, row, wym([], [[]]), jaki, bzap, N, H, F, (0 '|' 0), O), I, J, pt2, [K/zaimprzym(A, G, B, na)|L], M),
	fpt(I, J, M, G, B, row, wym([], [[]]), jaki, bzap, N, H, F, (0 '|' 0), O).

zaimprzym(G, A, I, taki, E, F, na) :-
	optional(J, [], A, H, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fpt(E, F, row, wym([], [[]]), przym, tk, L, neut, D, (0 '|' 0), M), G, H, pt3, [I/zaimprzym(taki, E, F, na)|J], K),
	fpt(G, H, K, E, F, row, wym([], [[]]), przym, tk, L, neut, D, (0 '|' 0), M).

zaimprzym(G, A, I, jakiś, E, F, na) :-
	optional(J, [], A, H, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fpt(E, F, row, wym([], [[]]), przym, bzap, L, neut, D, (0 '|' 0), M), G, H, pt4, [I/zaimprzym(jakiś, E, F, na)|J], K),
	fpt(G, H, K, E, F, row, wym([], [[]]), przym, bzap, L, neut, D, (0 '|' 0), M).

zaimprzym(J, C, L, A, G, B, na) :-
	member(A/H/I, [taki/tk/neut, jaki/bzap/pyt, jaki/bzap/pz, jaki/bzap/wz(jaki, B), jakiś/bzap/neut]),
	optional(M, [], C, K, spójnik(i(D, E), _, ni, po), {F=i(D, E)}, {F=ni}),
	register(modjaki(G, B, H, I, F, (0 '|' 0), O), J, K, mj1, [L/zaimprzym(A, G, B, na)|M], N),
	modjaki(J, K, N, G, B, H, I, F, (0 '|' 0), O).

flicz(H, I, J, A, B/C, uzg, D, E, F, G, na) :-
	register(fno(A, B/C, L, wym(M, [[]]), uzg, D, N, O, E, F, G, P), H, I, nol1, [J/flicz(A, B/C, uzg, D, E, F, G, na)], K),
	fno(H, I, K, A, B/C, L, wym(M, [[]]), uzg, D, N, O, E, F, G, P).

flicz(H, I, J, A, B/C, nuzg, D, E, F, G, na) :-
	różne(A, mian),
	register(fno(A, B/C, L, wym(M, [[]]), nuzg, D, N, O, E, F, G, P), H, I, nol2, [J/flicz(A, B/C, nuzg, D, E, F, G, na)], K),
	fno(H, I, K, A, B/C, L, wym(M, [[]]), nuzg, D, N, O, E, F, G, P).

flicz(E, F, G, mian, H/I, nuzg, A, B, C, D, na) :-
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, wym(K, [[]]), nuzg, A, L, M, B, C, D, N), E, F, nol3, [G/flicz(mian, H/I, nuzg, A, B, C, D, na)], J),
	fno(E, F, J, mian, r(mn(n), nmo(np(n)))/poj, 3, wym(K, [[]]), nuzg, A, L, M, B, C, D, N).

flicz(U, D, W, A, B/C, uzg, J, F, H, L, na) :-
	goal(fno(A, B/C, N, O, E, K, Y, Q, G, I, M, po), D, V, X),
	różne(E, [uzg|nuzg]),
	obldest(R, F, G),
	oblink(S, H, I),
	oblzap(P, [J, K]),
	oblpk(T, [L, M]),
	register(fno(A, B/C, N, O, uzg, P, A1, Q, R, S, T, B1), U, V, nol4, [W/flicz(A, B/C, uzg, J, F, H, L, na), D, X/fno(A, B/C, N, O, E, K, Y, Q, G, I, M, po)], Z),
	fno(U, V, Z, A, B/C, N, O, uzg, P, A1, Q, R, S, T, B1).

flicz(U, C, W, D, A/B, nuzg, J, F, H, L, na) :-
	goal(fno(dop, A/B, N, O, E, K, Y, Q, G, I, M, po), C, V, X),
	różne(D, mian),
	różne(E, [uzg|nuzg]),
	obldest(R, F, G),
	oblink(S, H, I),
	oblzap(P, [J, K]),
	oblpk(T, [L, M]),
	register(fno(D, A/B, N, O, nuzg, P, A1, Q, R, S, T, B1), U, V, nol6, [W/flicz(D, A/B, nuzg, J, F, H, L, na), C, X/fno(dop, A/B, N, O, E, K, Y, Q, G, I, M, po)], Z),
	fno(U, V, Z, D, A/B, N, O, nuzg, P, A1, Q, R, S, T, B1).

flicz(S, C, U, mian, A/B, nuzg, I, E, G, K, na) :-
	goal(fno(dop, A/B, W, M, D, J, X, O, F, H, L, po), C, T, V),
	różne(D, [uzg|nuzg]),
	obldest(P, E, F),
	oblink(Q, G, H),
	oblzap(N, [I, J]),
	oblpk(R, [K, L]),
	register(fno(mian, r(mn(n), nmo(np(n)))/poj, 3, M, nuzg, N, Z, O, P, Q, R, A1), S, T, nol8, [U/flicz(mian, A/B, nuzg, I, E, G, K, na), C, V/fno(dop, A/B, W, M, D, J, X, O, F, H, L, po)], Y),
	fno(S, T, Y, mian, r(mn(n), nmo(np(n)))/poj, 3, M, nuzg, N, Z, O, P, Q, R, A1).

flicz(M, B, O, G, H, I, J, C, ni, E, A) :-
	var(A),
	A=na,
	sequence_of(P, [], B, N, [modpart(flicz, _, D, ni, F, po)]^[obldest_iter, C, D, K]^[sprawdz_pk_iter, E, F, L]^[conajmniej1, 0, _, 1]),
	register(flicz(G, H, I, J, K, R, L, na), M, N, lim2, [O/flicz(G, H, I, J, C, ni, E, A)|P], Q),
	flicz(M, N, Q, G, H, I, J, K, R, L, na).

przyimek(K, B, M, D, A, na) :-
	goal(fno(A, O/P, Q, wym([], R), E, F, pre, G, H, I, C, po), B, L, N),
	oblpk(J, [ (0 '|' +), C]),
	register(fpm(D, A, E, F, G, H, I, J, T), K, L, pm1, [M/przyimek(D, A, na), B, N/fno(A, O/P, Q, wym([], R), E, F, pre, G, H, I, C, po)], S),
	fpm(K, L, S, D, A, E, F, G, H, I, J, T).

przyimek(K, B, M, D, A, na) :-
	goal(fpt(A, O/P, Q, wym([], R), E, F, G, H, I, C, po), B, L, N),
	oblpk(J, [ (0 '|' +), C]),
	register(fpmpt(D, A, E, F, G, H, I, J, T), K, L, pma1, [M/przyimek(D, A, na), B, N/fpt(A, O/P, Q, wym([], R), E, F, G, H, I, C, po)], S),
	fpmpt(K, L, S, D, A, E, F, G, H, I, J, T).

przyimek(K, C, M, A, B, na) :-
	(   równe(A, [z, za])
	->  B=bier
	;   równe(B, [dop, bier])
	),
	goal(fpt(pop, O/P, Q, wym([], R), E, F, G, H, I, D, po), C, L, N),
	oblpk(J, [ (0 '|' +), D]),
	register(fpmpt(A, pop, E, F, G, H, I, J, T), K, L, pma1, [M/przyimek(A, B, na), C, N/fpt(pop, O/P, Q, wym([], R), E, F, G, H, I, D, po)], S),
	fpmpt(K, L, S, A, pop, E, F, G, H, I, J, T).

przyimek(B, A, D, mimo, dop, na) :-
	goal(terminal(morf(F, że, comp)), A, C, E),
	register(spójnik(po, chociaż, ni, H), B, C, spoj34, [D/przyimek(mimo, dop, na), A, E/terminal(morf(F, że, comp))], G),
	spójnik(B, C, G, po, chociaż, ni, H).

przyimek(B, A, D, podczas, dop, na) :-
	goal(terminal(morf(F, gdy, comp)), A, C, E),
	register(spójnik(po, podczas, ni, H), B, C, spoj40, [D/przyimek(podczas, dop, na), A, E/terminal(morf(F, gdy, comp))], G),
	spójnik(B, C, G, po, podczas, ni, H).

przyimek(D, B, F, C, A, na) :-
	goal(zaimrzecz(to, A, H/poj, po), B, E, G),
	register(korelat(C/A, ni, J), D, E, kor1, [F/przyimek(C, A, na), B, G/zaimrzecz(to, A, H/poj, po)], I),
	korelat(D, E, I, C/A, ni, J).

formaprzym(I, A, K, E, F, G, H, na) :-
	optional(L, [], A, J, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fpt(E, F, G, H, przym, bzap, N, neut, D, (0 '|' 0), O), I, J, pt1, [K/formaprzym(E, F, G, H, na)|L], M),
	fpt(I, J, M, E, F, G, H, przym, bzap, N, neut, D, (0 '|' 0), O).

modjaki(G2, C, I2, A, B, R, S, T, U, po) :-
	sequence_of(J2, [D, C1/fpt(A, B, V, W, X, Y, P, Z, A1, B1, na)|I1], C, D, [fps(E, F, G, H, I, J, po)^[E]^[F]^[G], fpm(K, L, M, Q, N, H, I, J, po)^[K]^[L]^[M]^[N], fw(O, _, _, _, _, post, tak, H, I, J, po)^[zroblistę_iter, [], O, H1], modpart(fpt, P, H, I, J, po), modjaki(A, B, Q, H, I, J, po)]^[oblzap_iter, R, Q, D1]^[obldest_iter, S, H, E1]^[oblink_iter, T, I, F1]^[sprawdz_pk_iter, U, J, G1]),
	goal(fpt(A, B, V, W, X, Y, P, Z, A1, B1, na), D, J1, C1),
	W=wym(_, [_|_]),
	oblzap_iter(D1, Y, X1),
	obldest_iter(E1, Z, Y1),
	oblink_iter(F1, A1, Z1),
	sprawdz_pk_iter(G1, B1, A2),
	wyjmijl(H1, W, U1),
	sequence_of(I1, [], J1, H2, [fps(K1, L1, M1, N1, O1, P1, po)^[K1]^[L1]^[M1], fpm(Q1, R1, S1, W1, T1, N1, O1, P1, po)^[Q1]^[R1]^[S1]^[T1], fw(V1, _, _, _, _, post, tak, N1, O1, P1, po)^[oblwym_iter, U1, V1, B2], modpart(fpt, P, N1, O1, P1, po), modjaki(A, B, W1, N1, O1, P1, po)]^[oblzap_iter, X1, W1, C2]^[obldest_iter, Y1, N1, D2]^[oblink_iter, Z1, O1, E2]^[sprawdz_pk_iter, A2, P1, F2]),
	sprawdz_reszte(B2),
	register(fpt(A, B, V, wym(L2, bw), X, C2, P, D2, E2, F2, M2), G2, H2, ptm5, [I2/modjaki(A, B, R, S, T, U, po)|J2], K2),
	fpt(G2, H2, K2, A, B, V, wym(L2, bw), X, C2, P, D2, E2, F2, M2).

formalicz(E, F, G, A, B/C, D, na) :-
	register(flicz(A, B/C, D, bzap, neut, ni, (0 '|' 0), I), E, F, licz1, [G/formalicz(A, B/C, D, na)], H),
	flicz(E, F, H, A, B/C, D, bzap, neut, ni, (0 '|' 0), I).

formaprzys(I, A, K, E, F, G, H, na) :-
	optional(L, [], A, J, spójnik(i(B, C), _, ni, po), {D=i(B, C)}, {D=ni}),
	register(fps(E, F, G, H, D, (0 '|' 0), N), I, J, ps1, [K/formaprzys(E, F, G, H, na)|L], M),
	fps(I, J, M, E, F, G, H, D, (0 '|' 0), N).

korelat(K, A, M, D, I, po) :-
	goal(fzd(C, nk, E, F, G, H, ni, B, na), A, L, N),
	oblpk(J, [ (0 '|' 0), B]),
	register(fzd(C, D, E, F, G, H, I, J, P), K, L, zdk1, [M/korelat(D, I, po), A, N/fzd(C, nk, E, F, G, H, ni, B, na)], O),
	fzd(K, L, O, C, D, E, F, G, H, I, J, P).

korelat(E, A, G, B, ni, na) :-
	goal(spójnik(i(C, D), I, ni, po), A, F, H),
	register(korelat(B, i(C, D), K), E, F, kor3, [G/korelat(B, ni, na), A, H/spójnik(i(C, D), I, ni, po)], J),
	korelat(E, F, J, B, i(C, D), K).

zaimwzg(_, _, _, _, _, _, _, _) :-
	fail.

zaimprzym(C, D, E, jaki, A, B) :-
	register(zaimwzg(przym, A, B, G, H), C, D, zaim44n, [E/zaimprzym(jaki, A, B)], F),
	zaimwzg(C, D, F, przym, A, B, G, H).

zaimprzym(E, F, G, ten, A, r(B, nmo(C))/D) :-
	register(zaimno(rzecz, A, r(B, nmo(C))/D, I, co), E, F, zaim73, [G/zaimprzym(ten, A, r(B, nmo(C))/D)], H),
	zaimno(E, F, H, rzecz, A, r(B, nmo(C))/D, I, co).

zaimprzym(B, C, D, ten, A, r(mn(m(zy)), mo)/poj) :-
	register(zaimno(rzecz, A, r(mn(m(zy)), mo)/poj, F, kto), B, C, zaim73k, [D/zaimprzym(ten, A, r(mn(m(zy)), mo)/poj)], E),
	zaimno(B, C, E, rzecz, A, r(mn(m(zy)), mo)/poj, F, kto).

zaimprzym(C, D, E, ten, A, B) :-
	register(zaimno(przym, A, B, G, H), C, D, zaim73x, [E/zaimprzym(ten, A, B)], F),
	zaimno(C, D, F, przym, A, B, G, H).

zaimno(_, _, _, _, _, _, _, _) :-
	fail.

przyzlo(H, A, J, K, E/D, G, na) :-
	goal(terminal(morf(M, być, bedzie:C:B:imperf)), A, I, L),
	osoba(B, F),
	liczba(C, D),
	register(formaczas(os, nd, przy, ozn, E/D, F, G, O), H, I, n_cz7, [J/przyzlo(K, E/D, G, na), A, L/terminal(morf(M, być, bedzie:C:B:imperf))], N),
	formaczas(H, I, N, os, nd, przy, ozn, E/D, F, G, O).

przyzlo(I, A, K, s, F/E, H, na) :-
	goal(terminal(morf(M, się, qub)), A, B, L),
	goal(terminal(morf(O, być, bedzie:D:C:imperf)), B, J, N),
	osoba(C, G),
	liczba(D, E),
	register(formaczas1(n, os, nd, przy, ozn, F/E, G, H, Q), I, J, n_cz9, [K/przyzlo(s, F/E, H, na), A, L/terminal(morf(M, się, qub)), B, N/terminal(morf(O, być, bedzie:D:C:imperf))], P),
	formaczas1(I, J, P, n, os, nd, przy, ozn, F/E, G, H, Q).

formaczas1(_, _, _, _, _, _, _, _, _, _, _, _) :-
	fail.

condaglt(L, A, N, E, J, na) :-
	goal(terminal(morf(P, G, praet:D:F:B)), A, M, O),
	asagl(B, C, nagl),
	aspekt(C, H),
	liczba(D, E),
	rodzaj(F, I),
	rekcja_finitywna(G, K),
	register(formaczas(os, H, R, war, I/E, J, K, S), L, M, n_cz13, [N/condaglt(E, J, na), A, O/terminal(morf(P, G, praet:D:F:B))], Q),
	formaczas(L, M, Q, os, H, R, war, I/E, J, K, S).

condaglt(N, A, P, F, L, na) :-
	goal(terminal(morf(R, się, qub)), A, B, Q),
	goal(terminal(morf(T, H, praet:E:G:C)), B, O, S),
	asagl(C, D, nagl),
	aspekt(D, J),
	liczba(E, F),
	rodzaj(G, K),
	rekcja_finitywna(H, I),
	wyjmijwymaganie(sie, I, M),
	register(formaczas1(n, os, J, V, war, K/F, L, M, W), N, O, n_cz15, [P/condaglt(F, L, na), A, Q/terminal(morf(R, się, qub)), B, S/terminal(morf(T, H, praet:E:G:C))], U),
	formaczas1(N, O, U, n, os, J, V, war, K/F, L, M, W).

condaglt(C, D, E, B, A, na) :-
	register(posiłk(by(A), G/B, neut, ni, (0 '|' 0), H), C, D, po3, [E/condaglt(B, A, na)], F),
	posiłk(C, D, F, by(A), G/B, neut, ni, (0 '|' 0), H).

znakkonca(_, _, _, _, _) :-
	fail.

